(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     53462,       1230]*)
(*NotebookOutlinePosition[     54309,       1261]*)
(*  CellTagsIndexPosition[     54226,       1255]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[":Mathematica Version: 4.0", "Text"],

Cell[":Package Version: 1.0.4", "Text"],

Cell[":Copyright: public domain", "Text"],

Cell[":Name: fNBookForm2`", "Text"],

Cell[":Title: fNBookForm2", "Text"],

Cell[":Author: John Hendrickson (debguy@sourceforge.net)", "Text"],

Cell[":History: None", "Text"],

Cell[":Keywords: fNBookForm2 NumberForm", "Text"],

Cell[":Requirements: None", "Text"],

Cell[":Sources: all code is origional by author", "Text"],

Cell["\<\
:Summary:
\toops it's in help browser file for package jutils
\t\tjutils.help.nb
\t\tsome usage is defined below
\tNOTE:
\t\tsome funs are result of CreateModule used in
\t\tPeriodTableOfElements (to edit these funs use that)

\tby: John Hendrickson (debguy@sourceforge.net), 2013, public domain
\t\tcredit to many authors of math in general\
\>", "Text"],

Cell["\<\
:History: 

improved packaging

unlikely obscure problem due to mis-spelling. 1.0 had FractionalPart \
mispelled in one place.  If rounding, and acc and prec were both specified \
(remember mm doesn't allow it) and fractional and both equal excepting their \
fractional parts, would effect contest of prec frac winning between two close \
calls if acc had not already won, which then only might effect rounding style \
(the slope of % error eq.)\
\>", "Text"],

Cell[CellGroupData[{

Cell["setup", "Subsubsection"],

Cell[BoxData[
    \(\(\( (*\ suggested\ , \ 
      see\ the\ mm\ book\ *) \)\(\[IndentingNewLine]\)\(If[
      False, \[IndentingNewLine] (*\ On[MemoryConserve]\ *)  (*\ 
        may\ be\ causing\ crashes\ *) \[IndentingNewLine] (*\ 
        turn\ off\ has\ similar\ spelling\ messages\ \
*) \[IndentingNewLine]Off[General::"\<spell\>"]; \[IndentingNewLine]Unprotect[
        In, Out]; \[IndentingNewLine]Clear[In, 
        Out]; \[IndentingNewLine]Protect[In, 
        Out]; \[IndentingNewLine]$HistoryLength = 
        5; \[IndentingNewLine]MemoryInUse[];\[IndentingNewLine]]\)\)\)], \
"Input"],

Cell[BoxData[
    \(\(Needs["\<Miscellaneous`Units`\>"];\)\)], "Input",
  InitializationCell->True],

Cell["\<\
Needs[\"Miscellaneous`ChemicalElements`\"];
Needs[\"Miscellaneous`PhysicalConstants`\"];
Needs[\"Months`\"];
Needs[\"Miscellaneous`Calendar`\"];\
\>", "Text"],

Cell[BoxData[
    \(\(Needs["\<jutils`\>"];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(Map[Clear, Names["\<c2`p`*\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Map[Clear, Names["\<c2`*\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Map[\((Clear[ToString["\<fNBookForm2`\>" <> #]])\) &, {powerstab, 
          powerstable, powerstab1, powerstab2, powerstab3, powers, bookpower, 
          powerstab3, powerstab4, powerbook, bookexp, booknum, Sep, Units, 
          fNBookForm2, sd, opts, sep, u, showprec, printstate, rounding, 
          commas, fill, sigzeros, fNBookForm2Short, 
          fNBookForm2Arb}];\)\)], "Input"],

Cell[BoxData[
    \(\(Map[\((Clear[ToString["\<fNBookForm2`Private`\>" <> #]])\) &, {x, y, 
          u, v, w, z, n, s, k, ee, EE, units, sep, n, k, y, e, num, den, 
          debug, b, s1, s2}];\)\)], "Input"],

Cell[BoxData[
    \(\(BeginPackage["\<fNBookForm2`\>", {"\<Miscellaneous`Units`\>", \
"\<jutils`\>"}];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(powers::usage = "\<powers array\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(powerstab3::usage = "\<powers table\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(powerstab4::usage = "\<powers table\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(powerstable::usage = "\<powers table\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(powerbook::usage = "\<powerbook[int|string]  given n returns symbol, \
in style u, or e1 exp style if it was applicable but not in table.  1 is \
digit form, 2 is symbol form, 3 is letter form, 4 is string form. ie \
powerbook[3] -> k\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(powerbook::notinteger = "\<`1`\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(booknum::usage = "\<booknum[num_String,opts]  \"num unit\".  Converts \
fNBookForm output string to Expression.  The interpretation is a little \
wider, but it tries to restore precision as read from book to mm.  num can \
also be Symbol.  unit can be powers letter, e1 style exponent, missing, or \
Symbol.  opt Unit is for bookexp[, Unit].  If Symbol isn't recognized it is \
reflected.  For (ie. Tera) Convert[Tera,1] is an alternative.  Commas in \
input are ignored.  ie. booknum[\"3 m\"]->0.003\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(booknum::fields = "\<error too many fields in: \>" <> "\<\"\>" <> \
"\<`1`\>" <> "\<\"\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(booknum::nosplit = "\<no fields on split: \>" <> "\<\"\>" <> \
"\<`1`\>" <> "\<\"\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(bookexp::usage = "\<bookexp[Integer|String|Symbol]  looks up object \
in powers table and returns requested alias.  Default is type 1.  1 numberic  \
2 Symbol  3 letter  4 String.  ie. bookexp[Milli] == -3\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(fNBookForm2::usage = "\<fNBookForm2[num,opts]  Output to string using \
letter powers.  Condenses automatically while preserving significance.  Input \
can be InputForm.  Output form is also decided by preserving input style; \
letter formatting aside.  Options@fNBookForm2 == {c2`p`sd\[Rule]4,c2`p`u\
\[Rule]3,c2`p`sep\[Rule]space,c2`p`showprec\[Rule]False,c2`p`printstate\[Rule]\
False,c2`p`rounding\[Rule]0}.  sd is tot. width.  Rounding is off.  \
{0,1,2,3}.  On 1st estimated digit boundry (on .7 of `1.7):  1. don't round \
est dig but show  2. round into est dig and show  3. round off est dig (do \
not show).  Try fNBookForm2Arb for arbitrary numbers, booknum to import book \
nums, and fNBookForm2Short (shortest showprec).\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(fNBookForm2::"\<unformatted\>" = "\<`1`\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(fNBookForm2::"\<extra input\>" = "\<`1` : `2`\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(fNBookForm2::"\<fractional exponent\>" = "\<`1`\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(fNBookForm2::"\<unexpected error\>" = "\<`1`\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(fNBookForm2::"\<prec flooded acc\>" = "\<too many precise digits left \
of decimal left no room for accuracy, but were kept: `1`\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(fNBookForm2Short::usage = "\<fNBookForm2Short[___]  Shows shorter of \
the two results of showprec->True and showprec->False.  See ? \
fNBookForm2.\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(fNBookForm2Arb::usage = "\<fNBookForm2Arb[Rational|Integer,u:2]  \
Offers a version of Arbitrary Precision number with powers Symbol (ie, Milli) \
used to reduce.  With u 3 or 4 be prettier. Use for base 10 untested other \
bases.\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(Begin["\<`Private`\>"];\)\)], "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["powers", "Subsubsection"],

Cell[TextData[{
  "Before the symbol was standardized as da with the introduction of the \
International System of Units in 1960, various other symbols were more \
common, such as \"dk\", \"D\", and \"Da\". (in last release i couldn't find \
thes in CRC'72 or my book and used \"\" and fNBookForm assumed no abbrev. was \
avail.)\n\tCRC'72 used dkgr for dekagram, dg for decigram.  today they say \
\"dag\" or \"dg\"\n\tand call \"deka\" and unofficial spelling of deca (i \
doubt this, but ok)\n\ti'm correct: deka is 10 in old Greek, deca is the \
\"new\" spelling\ni'll leave \"da\" in but for real use I'd use \"D\" or \
maybe \"",
  StyleBox["d\"",
    FontSlant->"Italic"],
  ".  it may mess up a column alignment, but may come in handy if comparing \
to something else or appended to something else"
}], "Text"],

Cell[BoxData[
    \(\(powers = {\[IndentingNewLine]{24, 21, 18, 15, 12, 9, 6, 3, 2, 
            1, \(-1\), \(-2\), \(-3\)\[IndentingNewLine], \(-6\), \(-9\), \
\(-12\), \(-15\), \(-18\), \(-21\), \(-24\)}\[IndentingNewLine], {Yotta, 
            Zetta, Exa, Peta, Tera, Giga, Mega\[IndentingNewLine], Kilo, 
            Hecto, Deca, Deci, Centi, Milli, Micro\[IndentingNewLine], Nano, 
            Pico, Femto, Atto, Zepto, 
            Yocto}\[IndentingNewLine], {"\<Y\>", "\<Z\>", "\<E\>", "\<P\>", "\
\<T\>", "\<G\>", "\<M\>", "\<k\>", "\<h\>", "\<da\>", "\<d\>", "\<c\>", \
"\<m\>", "\<\[Micro]\>", "\<n\>", "\<p\>", "\<f\>", "\<a\>", "\<z\>", \
"\<y\>"}\[IndentingNewLine], {"\<Yotta\>", "\<Zetta\>", "\<Exa\>", \
"\<Peta\>", "\<Tera\>", "\<Giga\>", "\<Mega\>"\[IndentingNewLine], \
"\<Kilo\>", "\<Hecto\>", "\<Deca\>", "\<Deci\>", "\<Centi\>", "\<Milli\>", \
"\<Micro\>"\[IndentingNewLine], "\<Nano\>", "\<Pico\>", "\<Femto\>", \
"\<Atto\>", "\<Zepto\>", "\<Yocto\>"}\[IndentingNewLine] (*\ 
            NOTE : \ \[Micro]\ is\ Micro\ not\ \[Mu]\ Mu\ \
*) \[IndentingNewLine]};\)\)], "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["powerstable", "Subsubsection"],

Cell[BoxData[
    \(\(powerstab3 = 
        Module[{n, 
            s}, \[IndentingNewLine]Table[\[IndentingNewLine]s = 
              ToString[
                powers[\([1, 
                    i]\)]]; \
\[IndentingNewLine]{\[IndentingNewLine]"\<\!\(10\>" <> "\<\^\>" <> 
                s <> "\<\)\>"\[IndentingNewLine], 
              ToString[powers[\([2, i]\)]]\[IndentingNewLine], 
              ToString[
                powers[\([3, 
                    i]\)]]\[IndentingNewLine]}\[IndentingNewLine], {i, 1, 
              Length[powers[\([1]\)]]}\[IndentingNewLine]]];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(powerstab4 = 
        Table[Flatten[{powerstab3[\([i]\)], "\<  \>", 
              powerstab3[\([i + 10]\)]}], {i, 1, 10}];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(powerstab4 = 
        Prepend[powerstab4, {"\<Power\>", "\<Prefix\>", "\<Ab\>", "\<  \>", "\
\<Power\>", "\<Prefix\>", "\<Ab\>"}];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(powerstable = 
        GridBox[powerstab4, RowLines \[Rule] True, ColumnLines \[Rule] True, 
            GridFrame \[Rule] True] // DisplayForm;\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(GridBox[powerstab3, RowLines \[Rule] True, ColumnLines \[Rule] True] // 
      DisplayForm\)], "Input",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{

Cell["powerbook --  function", "Subsubsection"],

Cell[BoxData[
    \(powerbook[z_Integer | z_String, u_:  3] := 
      Module[{n, k, y}, \[IndentingNewLine]k = 
          ToExpression[
            z];  (*NumberFormat\ uses\ String*) \[IndentingNewLine]If[\[Not] \
IntegerQ[k], Message[powerbook::"\<notinteger\>", k]; 
          Return[z]]; \[IndentingNewLine]n = 
          Position[powers[\([1]\)], k]; \[IndentingNewLine]If[
          Length[n] == 0, "\<e\>" <> ToString[k], \[IndentingNewLine]y = 
            powers[\([u, n[\([1, 1]\)]]\)]; \[IndentingNewLine]If[
            y === "\<\>", "\<e\>" <> ToString[k], 
            y]\[IndentingNewLine]]]\)], "Input",
  InitializationCell->True],

Cell[CellGroupData[{

Cell[BoxData[
    \({powerbook[\(-6\)], powerbook["\<3\>"], powerbook["\<1.2\>"], 
      powerbook[{}], powerbook[snf2], powerbook[\(-7\)], powerbook[25], 
      powerbook[3, 1], powerbook[3, 2], powerbook[3, 3], 
      powerbook[3, 4]}\)], "Input"],

Cell[BoxData[
    \({"\[Micro]", "k", "1.2", powerbook[{}], powerbook[snf2], "e-7", "e25", 
      3, Kilo, "k", "Kilo"}\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["bookexp --  function", "Subsubsection"],

Cell[BoxData[
    \(\(bookexp[x_, w_ : 1] := 
        Module[{v}, \nv = Position[powers, x]; \n
          If[Length[v] > 0, \[IndentingNewLine]v = 
              v[\([1]\)]; \[IndentingNewLine]If[
              Length[v] \[Equal] 2, \[IndentingNewLine]v = 
                v[\([2]\)]; \[IndentingNewLine]v = 
                powers[\([w, 
                    v]\)];\[IndentingNewLine]]\[IndentingNewLine], \(v = \
{};\)\[IndentingNewLine]]; \nv\n];\)\)], "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["booknum --  function", "Subsubsection"],

Cell["\<\
this (and fNBookForm2) are right on the edge of needing a parser
\tbut external things are not widely supported
\tand both have \"unusual actions\" during parsing\
\>", "Text"],

Cell[BoxData[
    \(\(Options[booknum] = {Sep \[Rule] {"\< \>", "\<\[ThinSpace]\>"}, 
          Units \[Rule] 1};\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(booknum[x_String, opts___] := 
        Module[{v, s, ee, EE, sep, units}, \n
          sep = \(Sep /. {opts}\) /. Options[booknum]; \n
          units = \(Units /. {opts}\) /. Options[booknum]; \n
          If[StringLength[x] < 1, Return[x]]; \n
          xx = StringReplace[x, "\<,\>" \[Rule] "\<\>"]; \nbase = 10; \n
          s = Null; \nee = Null; \nEE = StringPosition[xx, "\<^^\>"]; \n
          If[EE != {}, 
            base = ToExpression[StringTake[xx, EE[\([1, 1]\)] - 1]]]; \n
          v = groupadjacent[Characters[xx], 
              true, \((Intersection[sep, {#}] == {})\) &]; \nEE = Length@v; \n
          If[Length@v \[Equal] 1, \[IndentingNewLine]v = 
              groupadjacent[Characters[xx], 
                true, \((DigitQ[#] || 
                      Intersection[{"\<^\>", "\<.\>", "\<`\>", "\<*\>"}, {#}] \
\[NotEqual] {} &)\)]; \[IndentingNewLine]EE = Length@v; \[IndentingNewLine]If[
              EE < 1, Message[booknum::"\<nosplit\>", x]; 
              Return[x]]; \[IndentingNewLine]If[
              EE > 1 && base \[LessEqual] 10 && 
                NumericQ[ToExpression@\(StringJoin@v[\([1]\)]\)], 
              v = StringJoin@{v[\([1]\)], sep[\([1]\)], Rest[v]}, 
              v = xx]; \[IndentingNewLine]v = 
              groupadjacent[Characters[v], 
                true, \((Intersection[
                        sep, {#}] == {})\) &];\[IndentingNewLine]]; \n
          If[Position[
                Characters[xx], "\<`\>"] \[Equal] {}, \[IndentingNewLine]EE = 
              groupadjacent[v[\([1]\)], 
                true, \((# != "\<*\>")\) &]; \[IndentingNewLine]s = 
              ToExpression[StringJoin[EE[\([1]\)]]]; \[IndentingNewLine]EE = 
              Length@Cases[
                  Characters@\(ToString@
                      s\), _?\((DigitQ[#] || 
                          LetterQ[#] &)\)]; \[IndentingNewLine]ee = 
              777;\[IndentingNewLine]]; \n
          s = ToExpression[StringJoin[v[\([1]\)]]]; \n
          If[ee \[Equal] 777, s = SetPrecision[s, EE]]; \nee = Null; \n
          If[Length@v > 1, v = Drop[v, 2], v = Drop[v, 1]]; \n
          If[Length@v > 1, 
            While[Intersection[sep, v[\([1]\)]] != {}, v = Drop[v, 1]]]; \n
          EE = Length@v; \nIf[EE \[Equal] 0, Return[s]]; \n
          If[EE > 1, Message[booknum::"\<fields\>", x]; Return[x]]; \n
          EE = groupadjacent[v[\([1]\)], 
              true, \((Intersection[{"\<e\>", "\<E\>"}, {#}] == {})\) &]; \n
          If[Length@EE \[GreaterEqual] 2, \[IndentingNewLine]EE = 
              Drop[EE, 1]; \[IndentingNewLine]If[
              NumericQ@\(ToExpression@\(StringJoin@
                    EE\)\), \[IndentingNewLine]units = 777; 
              v = EE;\[IndentingNewLine]];]; \nEE = StringJoin@v; \n
          If[units \[Equal] 
              777, \[IndentingNewLine]\(ee = 
                base^ToExpression@
                    EE;\)\[IndentingNewLine], \[IndentingNewLine]ee = 
              bookexp[EE, units]; \[IndentingNewLine]If[
              units \[Equal] 1 && NumericQ[ee], 
              ee = base^ee]; \[IndentingNewLine]If[ee === {}, 
              ee = ToExpression@EE];\[IndentingNewLine]]; \n
          If[ee =!= Null, s = s\ ee]; \ns\n];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(Remove[xxx, x];\)\)], "Input"],

Cell[BoxData[
    \(\(x = 5;\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \({\ booknum["\<2.0 \[Micro]\>"], 
      booknum["\<2 \[Micro]\>", Units \[Rule] 2], 
      booknum["\<2 \[Micro]\>", Units \[Rule] 3], booknum["\<2e0\>"], 
      1/10\ booknum["\<2 Ampere\>"], booknum["\<20.0 xyx\>"], , 
      booknum["\<2.0 + 3\>"], booknum[1], booknum[zzz], booknum["\<zzz\>"], 
      booknum["\<12 da\>"], booknum["\<1.1h\>"], booknum["\<1.11e2\>"], 
      booknum["\<123\>"], booknum["\<16^^10 e3\>"], booknum["\<123`2 e2\>"], 
      booknum["\<123``0\>"], booknum["\<1 Micro\>"], 
      booknum["\<1 Micro\>", Units \[Rule] 3], booknum["\<16^^10`3*^1\>"], 
      booknum["\<16^^10 da\>"], booknum["\<16^^10*^1\>"], booknum["\<x a\>"], 
      booknum["\<xxx a\>"] // N, booknum["\<2,000 \[Micro]\>"]}\)], "Input"],

Cell[BoxData[
    \({2.`1*^-6, 2.`1\ Micro, 2.`1\ "\[Micro]", 2.`1, 
      0.19999999995343`1\ Ampere, 20.`2\ xyx, Null, "2.0 + 3", booknum[1], 
      booknum[zzz], zzz, 120.`2, 109.99999999999979`2, 110.99999999999994`3, 
      123.`3, 65536.`2, 12300.`2, 123.`2.0899, 1.`1*^-6, 1.`1\ "\[Micro]", 
      256.`3.6124, 256.`2, 256.`2, 4.999999999999999`1*^-18, 1.`*^-18\ xxx, 
      0.002`4}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(Remove[head, \ cell, s, v, x, xx, sep, opts, ee, EE, units, 
        base];\)\)], "Input"],

Cell["recheck if rounding 16^^10*^2 is using right (4096 or 64)", "Text"],

Cell[BoxData[
    \({\ booknum["\<2.0 \[Micro]\>"], 
      booknum["\<2 \[Micro]\>", Units \[Rule] 2], 
      booknum["\<2 \[Micro]\>", Units \[Rule] 3], booknum["\<2e0\>"], 
      1/10\ booknum["\<2 Ampere\>"], booknum["\<20.0 xyx\>"], , 
      booknum["\<2.0 + 3\>"], booknum[1], booknum[zzz], booknum["\<zzz\>"], 
      booknum["\<12 da\>"], booknum["\<1.1h\>"], booknum["\<1.11e2\>"], 
      booknum["\<123\>"], booknum["\<16^^10 e3\>"], booknum["\<123`2 e2\>"], 
      booknum["\<123``0\>"], booknum["\<1 Micro\>"], 
      booknum["\<1 Micro\>", Units \[Rule] 3], booknum["\<16^^10`3*^1\>"], 
      booknum["\<16^^10 da\>"], booknum["\<16^^10*^1\>"], booknum["\<x a\>"], 
      booknum["\<xxx a\>"] // N, booknum["\<2,000 \[Micro]\>"]}\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["fNBookForm2 - test / debug / define", "Subsubsection"],

Cell["\<\
the code handles cases regular sig, sigzero, fill, ``, `, `` `
\ti'd never have used 1 fun for all that
\t\tit just accumulated a step at a time it was easier at the time
\tit is way too many things to handle at once
\t\tsee fNBookForm2Short offloads one task
\t\t--> sigzero and fill should be their own functions
\twell it's done.
\t\tand 1 fun is easier than 3 to update and more convenient to use
\t**\thowever i would not __dare try add a single extra load on it
\t**  its complicated enough as it is
because of that it needs to be modular and is pretty well so by design, ie \
...
\trounding must not add a \"0\" since how to react to it later would be awful
\trounding must use ++nexp instead\
\>", "Text"],

Cell["RunToBoundryCell", "Text"],

Cell["\<\
c2`p` keeps \"p\"arameters in separate area from the rest.
If your wondering why bother using c2` and c2`p see Remove note at end of \
section.\
\>", "Text"],

Cell[BoxData[
    \(\(Map[Remove, Names["\<c2`p`*\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Map[Remove, Names["\<c2`*\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Remove[fNBookForm2, x];\)\)], "Input"],

Cell[BoxData[
    \(\(Remove[opts, sd, u, sep, showprec, printstate, rounding, commas, 
        fill, sigzeros];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \({Names["\<c2`*\>"], Names["\<c2`p`*\>"]}\)], "Input"],

Cell[BoxData[
    \({{}, {}}\)], "Output"]
}, Open  ]],

Cell["\<\
NOTE:  vars4 isn't used for CreateModule anymore - now automatic.\
\
\>", "Text"],

Cell["\<\
vars4={\"c2`q\",\"c2`t\",\"c2`w\",\"c2`s\",\"c2`k\",\"c2`sign\",\"\
c2`mant\",\"c2`sig\",\"c2`base\",\"c2`acc\",\"c2`exp\",\"c2`prec\"\"c2`nprec\"\
,\"c2`nacc\",\"c2`nexp\",\"c2`sd\",\"c2`u\",\"c2`sep\",\"c2`showprec\",\"c2`\
printstate\",\"c2`rounding\",\"c2`commas\"};\
\>", "Text"],

Cell["Map[Remove,vars4];", "Text"],

Cell["\<\
test values - note Global`x is only to show it is NOT interfering\
\
\>", "Text"],

Cell[BoxData[
    \(\(Options[fNBookForm2] = {c2`p`sd \[Rule] 4, c2`p`u \[Rule] 3, 
          c2`p`sep \[Rule] "\<\[ThinSpace]\>", c2`p`showprec \[Rule] False, 
          c2`p`printstate \[Rule] False, c2`p`rounding \[Rule] 0, 
          c2`p`commas \[Rule] False, c2`p`fill \[Rule] False, 
          c2`p`sigzeros \[Rule] False};\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(fNBookForm2[c2`p`x_Integer | c2`p`x_Real | c2`p`x_String, 
          c2`p`opts___] := 
        Module[{c2`acc, c2`base, c2`c1, c2`c2, c2`commas, c2`debug, c2`exp, 
            c2`fexp, c2`fill, c2`getp, c2`k, c2`mant, c2`nacc, c2`nexp, 
            c2`nprec, c2`oldxw, c2`p, c2`prec, c2`printstate, c2`q, 
            c2`rounding, c2`roundok, c2`s, c2`sd, c2`sep, c2`showprec, 
            c2`sig, c2`sign, c2`sigzeros, c2`t, c2`u, c2`w}, \n
          c2`s = c2`p`x; \n
          If[Head[c2`p`x] \[Equal] Integer\  || \ 
              Head[c2`p`x] \[Equal] Real, \[IndentingNewLine]c2`s = 
              ToString[InputForm[c2`p`x]]]; \n
          c2`sd = \(c2`p`sd /. {c2`p`opts}\) /. Options[fNBookForm2]; \n
          c2`u = \(c2`p`u /. {c2`p`opts}\) /. Options[fNBookForm2]; \n
          c2`sep = \(c2`p`sep /. {c2`p`opts}\) /. Options[fNBookForm2]; \n
          c2`showprec = \(c2`p`showprec /. {c2`p`opts}\) /. 
              Options[fNBookForm2]; \n
          c2`printstate = \(c2`p`printstate /. {c2`p`opts}\) /. 
              Options[fNBookForm2]; \n
          c2`rounding = \(c2`p`rounding /. {c2`p`opts}\) /. 
              Options[fNBookForm2]; \n
          c2`commas = \(c2`p`commas /. {c2`p`opts}\) /. 
              Options[fNBookForm2]; \n
          c2`fill = \(c2`p`fill /. {c2`p`opts}\) /. Options[fNBookForm2]; \n
          c2`sigzeros = \(c2`p`sigzeros /. {c2`p`opts}\) /. 
              Options[fNBookForm2]; \nc2`mant = {}; c2`sig = {}; 
          c2`base = {}; c2`prec = {}; c2`acc = {}; c2`exp = {}; \n
          c2`nprec = False; c2`nacc = False; c2`nexp = False; \n
          c2`sign = "\<\>"; \nIf[c2`printstate, Print[c2`s]]; \n
          c2`s = StringReplace[
              c2`s, {"\<\\\>" -> "\<\>", "\<.^\>" -> "\<^\>", "\<.``\>" -> \
"\<``\>", "\<.`\>" -> "\<`\>", "\<.*\>" -> "\<*\>", "\<`.\>" \[Rule] \
"\<`0.\>"}]; \n
          If[StringTake[c2`s, \(-1\)] \[Equal] "\<`\>" || 
              StringMatchQ[c2`s, "\<*`\\**\>"], \[IndentingNewLine]c2`w = 
              StringReplace[
                c2`s, {"\<``*\>" -> "\<*\>"}]; \[IndentingNewLine]If[
              StringLength@c2`w \[NotEqual] StringLength@c2`s || 
                StringTake[
                    c2`s, \(-2\)] \[Equal] "\<``\>", \[IndentingNewLine]If[
                StringTake[c2`s, \(-2\)] \[Equal] "\<``\>", 
                c2`w = StringDrop[c2`s, \(-2\)]]; \[IndentingNewLine]c2`s = 
                c2`w; \[IndentingNewLine]If[
                NumberQ[c2`printstate], \[IndentingNewLine]c2`nacc = 
                  c2`printstate\[IndentingNewLine], \
\[IndentingNewLine]c2`nacc = 
                  Accuracy[
                    1`]\[IndentingNewLine]]]; \[IndentingNewLine]c2`w = 
              StringReplace[
                c2`s, {"\<`*\>" -> "\<*\>"}]; \[IndentingNewLine]If[
              StringLength@c2`w \[NotEqual] StringLength@c2`s || 
                StringTake[
                    c2`s, \(-1\)] \[Equal] "\<`\>", \[IndentingNewLine]If[
                StringTake[c2`s, \(-1\)] \[Equal] "\<`\>", 
                c2`w = StringDrop[c2`w, \(-1\)]]; \[IndentingNewLine]c2`s = 
                c2`w; \[IndentingNewLine]If[
                NumberQ[
                  c2`printstate], \[IndentingNewLine]\(c2`nprec = 
                    c2`printstate;\)\[IndentingNewLine], \
\[IndentingNewLine]\(c2`nprec = 
                    Precision[
                      1`];\)\[IndentingNewLine]]];\[IndentingNewLine]]; \n
          c2`w = Characters[c2`s]; \nLength[c2`w] > 0 || Return[c2`p`x]; \n
          If[c2`w[\([1]\)] \[Equal] "\<-\>", \[IndentingNewLine]c2`sign = \
"\<-\>"; \[IndentingNewLine]c2`w = Drop[c2`w, 1]\[IndentingNewLine]]; \n
          c2`q = \((Intersection[{"\<^\>", "\<.\>", "\<`\>", "\<*\>", "\< \
\>"}, {#}] \[Equal] {})\) &; \nc2`w = groupadjacent[c2`w, true, c2`q]; \n
          Length[c2`w] > 0 || Return[c2`p`x]; \n
          c2`debug[] := 
            If[c2`printstate \[Equal] True, 
              Print[{{"\<c2`t\>", c2`t}, \ {"\<w\>", c2`w}, \ {"\< S \>", 
                    c2`sign}, {"\< s \>", c2`sig}, {"\< m \>", 
                    c2`mant}, {"\< p \>", c2`prec, "\< \>", 
                    c2`nprec}, {"\< a \>", c2`acc, "\< \>", 
                    c2`nacc}, {"\< e \>", c2`exp, "\< \>", c2`nexp, "\< \>", 
                    c2`fexp}, {"\<sd=\>", c2`sd}, {"\<r=\>", 
                    c2`rounding}}]\[IndentingNewLine]]; \n
          SetAttributes[c2`getp, HoldFirst]; \n
          c2`getp[p_Symbol] := 
            If[Length[c2`w] > 0 && 
                c2`q@c2`w[\([1, 1]\)], \[IndentingNewLine]p = 
                Join[p, c2`w[\([1]\)]]; c2`w = Rest[c2`w]; True, False]; \n
          c2`getp[p_Symbol, c_] := 
            If[Length[c2`w] > 1 && c2`w[\([1, 1]\)] \[Equal] c, 
              If[c2`q@c2`w[\([2, 1]\)], p = Join[p, c2`w[\([2]\)]]; 
                c2`w = Drop[c2`w, 2]; True, 
                Message[fNBookForm2::"\<unformatted\>", c2`s]; \(-1\)], 
              False]; \n
          c2`getp[p_Symbol, c1_, c2_] := 
            If[Length[c2`w] > 2 && c2`w[\([1, 1]\)] \[Equal] c1 && 
                c2`w[\([2, 1]\)] \[Equal] c2, c2`w = Rest[c2`w]; 
              c2`getp[p, c2], \(False;\)]; \n
          If[c2`getp[c2`mant, "\<.\>"] \[Equal] \(-1\), Return[c2`p`x]]; \n
          c2`getp[c2`sig]; \n
          If[c2`getp[c2`base, "\<^\>", "\<^\>"] \[Equal] \(-1\), 
            Return[c2`p`x]]; \n
          If[c2`base \[NotEqual] {}, \[IndentingNewLine]c2`k = 
              c2`sig; \[IndentingNewLine]c2`sig = 
              c2`base; \[IndentingNewLine]c2`base = 
              c2`k;\[IndentingNewLine]]; \n
          If[c2`getp[c2`mant, "\<.\>"] \[Equal] \(-1\), Return[c2`p`x]]; \n
          c2`mant \[Equal] {} && c2`sig \[Equal] {} && Return[c2`p`x]; \n
          If[c2`getp[c2`acc, "\<`\>", "\<`\>"] \[Equal] \(-1\), 
            Return[c2`p`x]]; \nc2`t = {}; \n
          If[c2`getp[c2`t, "\<.\>"] \[Equal] \(-1\), Return[c2`p`x]]; \n
          If[Length[c2`t] > 0, c2`acc = Join[c2`acc, {"\<.\>"}, c2`t]]; \n
          If[c2`getp[c2`prec, "\<`\>"] \[Equal] \(-1\), Return[c2`p`x]]; \n
          c2`t = {}; \n
          If[c2`getp[c2`t, "\<.\>"] \[Equal] \(-1\), Return[c2`p`x]]; \n
          If[Length[c2`t] > 0, c2`prec = Join[c2`prec, {"\<.\>"}, c2`t]]; \n
          If[c2`getp[c2`acc, "\<`\>", "\<`\>"] \[Equal] \(-1\), 
            Return[c2`p`x]]; \nc2`t = {}; \n
          If[c2`getp[c2`t, "\<.\>"] \[Equal] \(-1\), Return[c2`p`x]]; \n
          If[Length[c2`t] > 0, c2`acc = Join[c2`acc, {"\<.\>"}, c2`t]]; \n
          If[c2`getp[c2`exp, "\<*\>", "\<^\>"] \[Equal] \(-1\), 
            Return[c2`p`x]]; \nc2`t = {}; \n
          If[c2`getp[c2`t, "\<.\>"] \[Equal] \(-1\), Return[c2`p`x]]; \n
          If[Length@c2`w =!= 0 && c2`w =!= {{"\<.\>"}}, 
            Message[fNBookForm2::"\<extra input\>", c2`s, c2`w]; 
            Return[c2`p`x]]; \n
          If[Length[c2`t] > 0, c2`exp = Join[c2`exp, {"\<.\>"}, c2`t]]; \n
          If[Length[c2`acc] > 0, \[IndentingNewLine]c2`nacc = 
              ToExpression[StringJoin[c2`acc]]]; \n
          If[Length[c2`prec] > 0, \[IndentingNewLine]c2`nprec = 
              ToExpression[StringJoin[c2`prec]]]; \n
          c2`nexp = 
            If[Length[c2`exp] > 0, \[IndentingNewLine]ToExpression[
                StringJoin[c2`exp]], 0]; \n
          c2`fexp = FractionalPart@c2`nexp; \n
          c2`nexp = IntegerPart@c2`nexp; \n
          If[Length[c2`base] > 0, 
            c2`base = ToExpression@\(StringJoin@c2`base\); 
            If[c2`base \[Equal] 1, c2`rounding = 0], c2`base = 10]; \n
          If[c2`base \[LessEqual] 0, 
            Message[fNBookForm2::"\<unformatted\>", c2`s]; Return[c2`p`x]]; \n
          c2`roundok = True; \nc2`debug[]; \nc2`w = Length[c2`sig]; \n
          If[\[Not] c2`sigzeros, \[IndentingNewLine]If[
              c2`w > 1 && 
                c2`sig[\([1]\)] \[Equal] "\<0\>", \[IndentingNewLine]c2`t = 
                1; \[IndentingNewLine]While[
                c2`w > c2`t && 
                  c2`sig[\([c2`t + 
                          1]\)] \[Equal] "\<0\>", \(++c2`t\)]; \
\[IndentingNewLine]c2`sig = Drop[c2`sig, c2`t]; \[IndentingNewLine]If[
                c2`sig \[Equal] {} && c2`mant \[Equal] {}, 
                c2`sig = {"\<0\>"}]; \[IndentingNewLine]\(c2`w = 
                  Length[c2`sig];\)\[IndentingNewLine]]; \
\[IndentingNewLine]If[
              c2`w \[Equal] 
                  0 || \((c2`w \[Equal] 1 && 
                      c2`sig[\([1]\)] \[Equal] "\<0\>" && 
                      c2`mant \[NotEqual] {})\) && 
                  c2`base > 1, \[IndentingNewLine]c2`q = 
                Length@c2`mant; \[IndentingNewLine]If[c2`q \[Equal] 0, 
                Return[c2`p`x]]; \[IndentingNewLine]c2`sig = {}; c2`w = 0; 
              c2`t = 0; \[IndentingNewLine]While[
                c2`t + 1 \[LessEqual] c2`q && 
                  c2`mant[\([c2`t + 
                          1]\)] \[Equal] "\<0\>", \(++c2`t\)]; \
\[IndentingNewLine]If[c2`t \[Equal] c2`q, \(--c2`t\); 
                c2`roundok = False]; \[IndentingNewLine]If[c2`t > 0, 
                c2`mant = Drop[c2`mant, c2`t]]; \[IndentingNewLine]c2`nexp -= 
                c2`t];\[IndentingNewLine]]; \n
          c2`sig = Join[c2`sig, c2`mant]; \nc2`mant = {}; \nc2`debug[]; \n
          c2`q = Length[c2`sig]; \nc2`acc = c2`sd; \n
          c2`oldxw = {c2`nexp, c2`w}; \nc2`k = False; \n
          If[c2`nprec < c2`sd && c2`q + c2`nacc\  > c2`nprec, 
            Message[fNBookForm2::"\<prec flooded acc\>", c2`s]]; \n
          If[c2`sd \[LessEqual] 0, c2`roundok = False]; \n
          If[c2`fill && c2`showprec === False && 
              c2`acc > 
                0 && \((c2`sig \[NotEqual] {"\<0\>"} || 
                  c2`sigzeros)\), \[IndentingNewLine]If[c2`printstate, 
              Print["\<s0=\>", c2`sig, "\< ne=\>", 
                c2`nexp]]; \[IndentingNewLine]If[c2`printstate, 
              Print["\<add left acc 0's\>"]; 
              c2`debug[]]; \[IndentingNewLine]c2`q = 
              Length@c2`sig; \[IndentingNewLine]c2`exp = 
              c2`nexp - \((c2`q - c2`w)\); \[IndentingNewLine]If[
              NumberQ@c2`nacc, c2`t = c2`nacc, 
              If[NumberQ@c2`nprec, c2`t = c2`nprec, 
                c2`t = c2`q]]; \[IndentingNewLine]c2`prec = 
              c2`exp + c2`q; \[IndentingNewLine]If[c2`printstate, 
              Print["\<s1=\>", c2`sig, "\< pr=\>", c2`prec, "\< e=\>", 
                c2`exp, "\< q=\>", c2`q, "\< t=\>", 
                c2`t]]; \[IndentingNewLine]If[
              c2`prec < 0 && 
                c2`t \[GreaterEqual] 
                  0, \[IndentingNewLine]c2`prec = \(-c2`prec\); \
\[IndentingNewLine]c2`t = Ceiling@c2`t; \[IndentingNewLine]If[
                c2`prec > c2`sd, \[IndentingNewLine]c2`sig = {}; 
                c2`roundok = False; 
                c2`prec = c2`sd\[IndentingNewLine], \[IndentingNewLine]If[
                  NumberQ@c2`nacc && c2`prec > c2`t, c2`prec = c2`t; 
                  c2`roundok = False; 
                  c2`sig = {}]\[IndentingNewLine]]; \[IndentingNewLine]c2`sig \
= Join[Table["\<0\>", {c2`s, 1, c2`prec}], 
                  c2`sig]; \[IndentingNewLine]c2`nexp = 0; 
              c2`w = 0; \[IndentingNewLine]c2`q = 
                Length[c2`sig]; \[IndentingNewLine]c2`fill = 
                c2`prec; \[IndentingNewLine]If[c2`printstate, 
                Print["\<n1=\>", c2`nexp, "\< p=\>", c2`prec, "\< acc=\>", 
                  c2`acc, \ "\< fill=\>", c2`fill]; 
                c2`debug[]]\[IndentingNewLine]]\[IndentingNewLine]]; \n
          If[c2`nacc =!= False, \[IndentingNewLine]c2`t = 
              If[c2`rounding \[Equal] 3, Floor[c2`nacc], 
                Ceiling[c2`nacc]]; \[IndentingNewLine]c2`exp = 
              c2`nexp - \((c2`q - c2`w)\); \[IndentingNewLine]If[
              c2`exp <= \(-c2`t\), \[IndentingNewLine]If[c2`printstate, 
                Print["\<t=\>", c2`t, "\< q=\>", c2`q, "\< e=\>", 
                  c2`exp, "\< a=\>", 
                  c2`q + c2`exp + c2`t]]; \[IndentingNewLine]c2`t = 
                c2`q + c2`exp + c2`t; \[IndentingNewLine]If[c2`t <= c2`sd, 
                c2`sd = c2`t; c2`k = c2`nacc]\[IndentingNewLine]]]; \n
          If[c2`nprec =!= False, \[IndentingNewLine]c2`t = 
              If[c2`rounding == 3, Floor[c2`nprec], 
                Ceiling[c2`nprec]]; \[IndentingNewLine]If[c2`fill > 0, 
              c2`t += c2`fill]; \[IndentingNewLine]If[
              c2`t \[LessEqual] c2`sd, \[IndentingNewLine]c2`sd = 
                c2`t; \[IndentingNewLine]If[
                c2`sd == 0 && c2`rounding \[NotEqual] 3, 
                c2`roundok = False]; \[IndentingNewLine]If[
                c2`k \[Equal] False || 
                  FractionalPart@c2`nprec \[LessEqual] 
                    FractionalPart@c2`nacc, 
                c2`k = c2`nprec]; \[IndentingNewLine]If[
                c2`nprec \[LessEqual] 0, c2`sd = 0; 
                c2`roundok = False]\[IndentingNewLine]]]; \n
          If[c2`q > c2`sd, \[IndentingNewLine]If[c2`sd < 0, c2`sd = 0; 
              c2`roundok = False]; \[IndentingNewLine]If[c2`sd < c2`fill, 
              c2`fill = c2`sd]; \[IndentingNewLine]c2`mant = 
              Drop[c2`sig, c2`sd]; \[IndentingNewLine]c2`sig = 
              Take[c2`sig, c2`sd]\[IndentingNewLine]]; \n
          If[c2`printstate, 
            Print["\<before rounding\>", "\< rok=\>", c2`roundok, "\< k=\>", 
              c2`k]; c2`debug[]]; \n
          If[c2`rounding > 0 && Length[c2`mant] > 0 && 
              c2`roundok && \((\[Not] \((c2`k =!= False && 
                      c2`rounding \[Equal] 1)\))\), \[IndentingNewLine]If[
              c2`printstate, Print["\<will check rounding\>"]; 
              c2`debug[];]; \[IndentingNewLine]If[
              c2`k =!= False, \[IndentingNewLine]If[
                c2`base \[NotEqual] 10, \[IndentingNewLine]c2`t = 
                  ToExpression[
                    ToString[c2`base] <> "\<^^\>" <> 
                      StringJoin[c2`mant]]\[IndentingNewLine], 
                c2`t = ToExpression@\(StringJoin@
                      c2`mant\)\[IndentingNewLine]]; \[IndentingNewLine]c2`t \
= c2`base\ c2`t/Power[c2`base, Length@c2`mant]; \[IndentingNewLine]c2`prec = 
                c2`base\ \((1 - 
                      FractionalPart[Abs[c2`k]])\); \[IndentingNewLine]If[
                c2`prec \[GreaterEqual] c2`base, c2`t = 0, 
                c2`t -= c2`prec]\[IndentingNewLine], 
              c2`t = ToExpression@
                  c2`mant[\([1]\)]\[IndentingNewLine]]; \[IndentingNewLine]If[
              c2`t \[GreaterEqual] c2`base/2, \[IndentingNewLine]c2`s = 
                False; \[IndentingNewLine]If[c2`sig \[Equal] {}, 
                c2`sig = {"\<0\>"}, 
                If[c2`sig[\([1]\)] == "\<0\>", c2`s = True; 
                  c2`exp = Length@c2`sig]]; \[IndentingNewLine]If[
                c2`base \[NotEqual] 10, \[IndentingNewLine]c2`t = 
                  ToExpression[
                    ToString[c2`base] <> "\<^^\>" <> 
                      StringJoin[c2`sig]]\[IndentingNewLine], 
                c2`t = 
                  ToExpression@\(StringJoin@
                      c2`sig\)\[IndentingNewLine]]; \[IndentingNewLine]If[\
\[Not] NumberQ@c2`t, Message[fNBookForm2::"\<unexpected error\>", c2`sig]; 
                Return[c2`p`x]]; \[IndentingNewLine]\(++c2`t\); \
\[IndentingNewLine]If[
                c2`base == 10, \[IndentingNewLine]c2`sig = 
                  Characters@\(ToString@
                      c2`t\)\[IndentingNewLine], \[IndentingNewLine]c2`t = 
                  Characters@\(ToString@
                      BaseForm[c2`t, c2`base]\); \[IndentingNewLine]c2`prec = 
                  Position[c2`t, "\<\n\>"]; \[IndentingNewLine]If[
                  c2`prec \[NotEqual] {}, 
                  c2`t = Take[c2`t, 
                      c2`prec[\([1, 1]\)] - 1]]; \[IndentingNewLine]c2`sig = 
                  c2`t\[IndentingNewLine]]; \[IndentingNewLine]If[
                c2`s, \[IndentingNewLine]c2`s = 
                  Table["\<0\>", {c2`prec, 1, 
                      c2`exp - Length@c2`sig}]; \[IndentingNewLine]c2`sig = 
                  Join[c2`s, c2`sig]; \[IndentingNewLine]If[c2`fill > 0, 
                  If[c2`sig[\([c2`fill]\)] \[NotEqual] "\<0\>", \
\[IndentingNewLine]\(--c2`fill\); 
                    If[Last@c2`sig \[Equal] "\<0\>", 
                      c2`sig = 
                        Drop[c2`sig, \(-1\)]]\[IndentingNewLine]]]\
\[IndentingNewLine]]; \[IndentingNewLine]c2`q = 
                Length@c2`sig; \[IndentingNewLine]If[
                c2`q > c2`sd, \[IndentingNewLine]\(++c2`nexp\); \
\[IndentingNewLine]If[
                  c2`sd == 0 && \((c2`rounding \[Equal] 
                          3 || \((c2`k =!= False && 
                            c2`k =!= 
                              c2`nprec)\))\), \[IndentingNewLine]c2`sd = 1, 
                  c2`sig = 
                    Take[c2`sig, 
                      c2`sd]\[IndentingNewLine]]\[IndentingNewLine]]; \
\[IndentingNewLine]c2`mant[\([1]\)] = "\<0\>"\[IndentingNewLine]]]; \n
          c2`q = Length@c2`sig; \n
          If[c2`fill \[GreaterEqual] 0 && c2`sigzeros === False && c2`q > 0 && 
              c2`sig[\([1]\)] \[Equal] "\<0\>" && 
              Complement[
                  c2`sig, {"\<0\>"}] \[Equal] {}, \[IndentingNewLine]If[
              c2`printstate, Print["\<fixup 0's\>"]; 
              c2`debug[]]; \[IndentingNewLine]{c2`nexp, c2`w} = c2`oldxw; 
            c2`sig = {"\<0\>"}; c2`fill = 0; c2`q = 1\[IndentingNewLine]]; \n
          If[c2`acc > 0, \[IndentingNewLine]If[
              c2`nacc =!= False, \[IndentingNewLine]c2`t = 
                If[c2`rounding \[Equal] 3, Floor[c2`nacc], 
                  Ceiling[c2`nacc]]; \[IndentingNewLine]If[
                c2`showprec \[Equal] False, \[IndentingNewLine]If[
                  c2`printstate, Print["\<add right acc 0's\>"]; 
                  c2`debug[]]; \[IndentingNewLine]If[c2`printstate, 
                  Print["\<s0=\>", c2`sig, "\< ne=\>", 
                    c2`nexp]]; \[IndentingNewLine]c2`exp = 
                  c2`nexp - \((c2`q - c2`w)\); \[IndentingNewLine]c2`prec = 
                  c2`t + c2`exp; \[IndentingNewLine]If[\[Not] \((c2`sigzeros === 
                          False && \((c2`q == 0 || 
                            c2`sig == {"\<0\>"})\))\), \
\[IndentingNewLine]c2`s = c2`prec; \[IndentingNewLine]If[
                    c2`s + c2`q > c2`acc, 
                    c2`s = c2`acc - c2`q]; \[IndentingNewLine]If[c2`s > 0, 
                    c2`sig = 
                      Join[c2`sig, 
                        Table["\<0\>", {c2`prec, 1, 
                            c2`s}]]]\[IndentingNewLine]]\[IndentingNewLine]]; \
\[IndentingNewLine]If[c2`printstate, 
                Print["\<s2=\>", c2`sig, "\< t=\>", c2`t, "\< q=\>", 
                  c2`q]]; \[IndentingNewLine]If[
                c2`q \[Equal] 0 || c2`sig \[Equal] {"\<0\>"}, 
                c2`sig = {"\<0\>"}; \[IndentingNewLine]c2`nexp = \(-c2`t\) + 
                    1; c2`w = 0; \[IndentingNewLine]If[
                  c2`rounding \[Equal] 3 && 
                    Abs@\(FractionalPart@
                          c2`nacc\) >  .5, \(--c2`nexp\)]; \
\[IndentingNewLine]If[c2`printstate, 
                  Print["\<lo0\>"]]]; \[IndentingNewLine]If[c2`printstate, 
                Print["\<s2=\>", c2`sig, "\< ne=\>", c2`nexp, "\< e=\>", 
                  c2`exp]]\[IndentingNewLine]]; \[IndentingNewLine]If[
              c2`nprec \[GreaterEqual] 0 && 
                c2`nacc \[Equal] False, \[IndentingNewLine]c2`t = 
                If[c2`rounding == 3, Floor[c2`nprec], 
                  Ceiling[c2`nprec]]; \[IndentingNewLine]c2`exp = 
                c2`nexp - \((c2`q - c2`w)\); \[IndentingNewLine]If[
                c2`showprec \[Equal] False, \[IndentingNewLine]If[
                  c2`printstate, Print["\<add prec 0's\>"]; 
                  c2`debug[]]; \[IndentingNewLine]If[c2`printstate, 
                  Print["\<s0=\>", c2`sig, "\< ne=\>", 
                    c2`nexp]]; \[IndentingNewLine]If[c2`fill > 0, 
                  c2`t += 
                    c2`fill]; \[IndentingNewLine]If[\[Not] \((c2`sigzeros === 
                          False && \((c2`q == 0 || 
                            c2`sig == {"\<0\>"})\))\), \
\[IndentingNewLine]c2`s = c2`t - c2`q; \[IndentingNewLine]If[
                    c2`s + c2`q > c2`acc, 
                    c2`s = c2`acc - c2`q]; \[IndentingNewLine]If[c2`s > 0, 
                    c2`sig = 
                      Join[c2`sig, 
                        Table["\<0\>", {c2`prec, 1, 
                            c2`s}]]];\[IndentingNewLine]]\[IndentingNewLine]];\
 \[IndentingNewLine]If[c2`printstate, 
                Print["\<s2=\>", c2`sig, "\< t=\>", c2`t, "\< q=\>", 
                  c2`q]]; \[IndentingNewLine]If[
                c2`q \[Equal] 0 || c2`sig \[Equal] {"\<0\>"}, 
                c2`sig = {"\<0\>"}; \[IndentingNewLine]c2`nexp = 
                  c2`exp - c2`t + 2; 
                c2`w = 0; \[IndentingNewLine]If[
                  c2`q \[Equal] 0, \(--c2`nexp\)]; \[IndentingNewLine]If[
                  c2`rounding \[Equal] 3 && 
                    Abs@\(FractionalPart@
                          c2`nprec\) >  .5, \(--c2`nexp\)]; \
\[IndentingNewLine]If[c2`printstate, 
                  Print["\<lo0\>"]]\[IndentingNewLine]]; \
\[IndentingNewLine]If[c2`printstate, 
                Print["\<s2=\>", c2`sig, "\< ne=\>", c2`nexp, "\< e=\>", 
                  c2`exp]]\[IndentingNewLine]]\[IndentingNewLine]]; \n
          c2`q = Length[c2`sig]; \nc2`nexp = c2`nexp - \((c2`q - c2`w)\); \n
          c2`debug[]; \nc2`t = 0; \n
          If[c2`nexp < 0 && c2`q > 1 && 
              c2`u > 0, \[IndentingNewLine]If[\(-c2`q\) \[GreaterEqual] 
                c2`nexp, c2`k = \(-c2`q\) + 1, 
              c2`k = c2`nexp]; \[IndentingNewLine]c2`t = c2`k; 
            c2`nexp -= c2`k; c2`q += c2`k]; \n
          If[\(Mod[c2`nexp, 3] \[NotEqual] 0 && 
                Abs[c2`nexp] \[GreaterEqual] 3\) && 
              c2`u > 0, \[IndentingNewLine]c2`k = 
              3 - Mod[c2`nexp, 3]; \[IndentingNewLine]If[
              c2`q > c2`k && \((c2`nexp < 0 || \(-c2`t\) \[LessEqual] 
                      3 - c2`k)\), \[IndentingNewLine]c2`nexp += c2`k; 
              c2`t -= c2`k; 
              c2`k = 0;\[IndentingNewLine]]; \[IndentingNewLine]If[
              c2`k \[NotEqual] 0 && \(-c2`t\) \[GreaterEqual] 
                  3 - c2`k, \[IndentingNewLine]c2`nexp -= \((3 - c2`k)\); 
              c2`t += \((3 - c2`k)\)\[IndentingNewLine]]]; \n
          If[c2`t \[NotEqual] 0, 
            c2`sig = Insert[c2`sig, "\<.\>", c2`t - 1]]; \nc2`debug[]; \n
          If[c2`commas, \[IndentingNewLine]c2`q = 
              Length@c2`sig; \[IndentingNewLine]c2`w = 
              Position[c2`sig, "\<.\>"]; \[IndentingNewLine]If[
              c2`w \[NotEqual] {}, 
              c2`q = c2`w[\([1, 1]\)] - 1]; \[IndentingNewLine]c2`w = 
              1; \[IndentingNewLine]While[c2`q > 1, 
              If[Mod[c2`w, 3] \[Equal] 0, 
                c2`sig = 
                  Insert[c2`sig, "\<,\>", 
                    c2`q]]; \(--c2`q\); \(++c2`w\)]\[IndentingNewLine]]; \n
          c2`w = "\<\>"; \n
          If[c2`showprec =!= False, \[IndentingNewLine]If[
              c2`base \[NotEqual] 10, 
              c2`sign = 
                ToString[c2`base] <> "\<^^\>" <> 
                  c2`sign]; \[IndentingNewLine]If[
              c2`nacc \[Equal] False && 
                c2`nprec \[Equal] 
                  False, \[IndentingNewLine]c2`nacc = \(-\((c2`t + \((c2`nexp \
+ c2`fexp)\))\)\); \[IndentingNewLine]c2`nprec = 
                c2`q - c2`t\[IndentingNewLine]]; \[IndentingNewLine]If[
              NumberQ@c2`nacc, 
              c2`w = c2`w <> "\<``\>" <> 
                  ToString[c2`nacc]]; \[IndentingNewLine]If[NumberQ@c2`nprec, 
              c2`w = c2`w <> "\<`\>" <> 
                  ToString[c2`nprec]]; \[IndentingNewLine]If[
              c2`showprec \[Equal] All, \[IndentingNewLine]If[
                c2`fexp === 
                  0, \[IndentingNewLine]\(c2`w = 
                    c2`w <> "\<*^\>" <> 
                      ToString[c2`nexp];\)\[IndentingNewLine], 
                c2`w = c2`w <> "\<*^\>" <> 
                    ToString@\(InputForm@\((c2`nexp + 
                            c2`fexp)\)\)]; \[IndentingNewLine]c2`nexp = 0; 
              c2`fexp = 0\[IndentingNewLine]]]; \nc2`t = "\<\>"; 
          c2`s = Abs@c2`u; \n
          If[c2`sig \[NotEqual] {} && 
              c2`nexp + c2`fexp \[NotEqual] 0, \[IndentingNewLine]If[
              c2`fexp === 0 && c2`s > 1, \[IndentingNewLine]c2`t = 
                ToString@
                  powerbook[ToString[c2`nexp], 
                    c2`s]\[IndentingNewLine], \[IndentingNewLine]c2`t = \
"\<e\>" <> ToString@\(InputForm@\((c2`nexp + 
                          c2`fexp)\)\)\[IndentingNewLine]]\[IndentingNewLine]]\
; \nIf[c2`showprec =!= False && Length@c2`sig \[Equal] 0 && c2`sd > 0, 
            c2`sig = {"\<0\>"}]; \n
          If[c2`t \[Equal] "\<\>", c2`sep = "\<\>"]; \n
          c2`s = c2`sign <> c2`sig <> c2`w <> c2`sep <> c2`t; \n
          c2`s\n];\)\)], "Input",
  InitializationCell->True],

Cell["\<\
(* 
Remove[vars4]; no longer needed, c2`* does this
Map[Remove,Names[\"c2`p`*\"]]; do NOT do this, param. vars are used by module
*)\
\>", "Text"],

Cell[BoxData[{
    \(\(Map[Remove, Names["\<c2`*\>"]];\)\), "\[IndentingNewLine]", 
    \(\(Remove[head, 
        cell];\)\[IndentingNewLine] (*\(needed\)\(?\)*) \), "\
\[IndentingNewLine]", 
    \(\(Remove[opts, sd, u, sep, showprec, PrintState, rounding, commas, 
        fill, sigzeros];\)\ \), "\[IndentingNewLine]", 
    \(\(Remove[x];\)\)}], "Input"],

Cell["\<\
If[c2`printstate,Print[\"n=\",c2`k,\"sd=\",c2`sd,\"rnd=\",c2`\
rounding]];
If[c2`printstate,Print[{c2`sig,c2`nexp,c2`sd}];];
Print[\"q=\",c2`q,\" acc/ti=\",c2`t,\" nexp=\",c2`nexp,\" w=\",c2`w,\" \
expf=\",c2`nexp-(c2`q-c2`w),\" tf=\",c2`t+c2`nexp-(c2`q-c2`w)];
Print[\"q=\",c2`q,\" p=\",c2`nprec,\" t=\",c2`t,\" sd=\",c2`sd,\" \
sig=\",c2`sig];\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\ \)\(PrettyDate[]\)\)\)], "Input"],

Cell[BoxData[
    \("Sunday, October 13 2013.  4:45:22 p.m. -4\[ThinSpace]GMT"\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["fNBookForm2Short", "Subsubsection"],

Cell[BoxData[
    \(fNBookForm2Short[x___] := 
      Module[{s1, s2}, \[IndentingNewLine]s1 = 
          fNBookForm2[x, 
            c2`p`showprec \[Rule] False]; \[IndentingNewLine]s2 = 
          fNBookForm2[x, c2`p`showprec \[Rule] True]; \[IndentingNewLine]If[
          StringLength@s2 < StringLength@s1, s2, 
          s1]\[IndentingNewLine]]\)], "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["fNBookForm2Arb", "Subsubsection"],

Cell["arbitrary powers suggester", "Text"],

Cell[BoxData[
    \(\(fNBookForm2Arb[x_Rational | x_Integer, u_Integer:  2] := 
        Module[{n, k, y, e, num, den, debug = False, 
            b}, \[IndentingNewLine]b = 10; \[IndentingNewLine]e = 
            First@\(Rest@MantissaExponent[N[x]]\); \[IndentingNewLine]If[
            e > 0, \(--e\), \(--e\)]; \[IndentingNewLine]If[e \[Equal] 0, 
            Return[x]]; \[IndentingNewLine]k = 1; 
          n = 1; \[IndentingNewLine]If[
            Abs[e] > 3 && 
              Mod[e, 3] =!= 0, \[IndentingNewLine]\(If[
                e < 0, \[IndentingNewLine]k = 
                  Mod[e, 3]; \[IndentingNewLine]e -= 
                  k; \[IndentingNewLine]k = 
                  b^k;\[IndentingNewLine], \[IndentingNewLine]k = 
                  3 - Mod[e, 3]; \[IndentingNewLine]e += 
                  k; \[IndentingNewLine]k = 
                  1/\((b^k)\);\[IndentingNewLine]];\)\[IndentingNewLine]]; \
\[IndentingNewLine]If[e > 24, k *= b^\((e - 24)\); 
            e = 24]; \[IndentingNewLine]If[e < \(-24\), k *= b^\((24 + e)\); 
            e = \(-24\)]; \[IndentingNewLine]If[e \[NotEqual] 0, 
            n = powerbook[e, u]]; \[IndentingNewLine]If[debug, 
            Print["\<nk=\>", n\ k, "\< n=\>", n, "\< k=\>", k, "\< e=\>", 
              e, "\< b=\>", b]]; \[IndentingNewLine]If[
            u \[Equal] 3 || u \[Equal] 4, \[IndentingNewLine]y = 
              x\ \((b^\(-e\))\); \[IndentingNewLine]num = 
              Numerator@y; \[IndentingNewLine]den = 
              Denominator@y; \[IndentingNewLine]If[
              den \[NotEqual] 1, \[IndentingNewLine]DisplayForm[
                RowBox[{FractionBox[num, den], "\< \>", 
                    n}]]\[IndentingNewLine], 
              DisplayForm[
                RowBox[{num, "\< \>", 
                    n}]]\[IndentingNewLine]]\[IndentingNewLine], 
            x\ \((b^\(-e\))\)\ n]\[IndentingNewLine]];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(x = 200000000000000000000;\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(fNBookForm2[N[x, 30]]\)], "Input"],

Cell[BoxData[
    \("200.0\[ThinSpace]E"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fNBookForm2Arb[x] // N\)], "Input"],

Cell[BoxData[
    \(0.2`\ Zetta\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(200\ 10^18 \[Equal]  .2\ 10^21\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \({10^\(-7\)\ \((1/35)\) // N, 20/7 // N}\)], "Input"],

Cell[BoxData[
    \({2.857142857142857`*^-9, 2.857142857142857`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \({fNBookForm2Arb[10^\(-7\)\ \((1/35)\), 3], fNBookForm2Arb[30, 3], 
      fNBookForm2Arb[2/10, 3]}\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        TagBox[\(20\/7\ n\),
          DisplayForm], ",", 
        TagBox[\(3\ da\),
          DisplayForm], ",", 
        TagBox[\(2\ d\),
          DisplayForm]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \({fNBookForm2Arb[10^\(-7\)\ \((1/35)\), 4], fNBookForm2Arb[30, 4], 
      fNBookForm2Arb[2/10, 4]}\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        TagBox[\(20\/7\ Nano\),
          DisplayForm], ",", 
        TagBox[\(3\ Deca\),
          DisplayForm], ",", 
        TagBox[\(2\ Deci\),
          DisplayForm]}], "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(Remove[x];\)\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["end package", "Subsubsection"],

Cell[BoxData[
    \(\(End[];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(EndPackage[];\)\)], "Input",
  InitializationCell->True,
  CellTags->"(lic2) In[270]:="],

Cell[BoxData[
    \(\(On[General::"\<spell\>"];\)\)], "Input"]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1280}, {0, 1024}},
AutoGeneratedPackage->None,
WindowSize->{680, 600},
WindowMargins->{{Automatic, 106}, {Automatic, 41}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "(lic2) In[270]:="->{
    Cell[53271, 1221, 110, 3, 27, "Input",
      InitializationCell->True,
      CellTags->"(lic2) In[270]:="]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"(lic2) In[270]:=", 54088, 1247}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 41, 0, 31, "Text"],
Cell[1761, 51, 39, 0, 31, "Text"],
Cell[1803, 53, 41, 0, 31, "Text"],
Cell[1847, 55, 35, 0, 31, "Text"],
Cell[1885, 57, 35, 0, 31, "Text"],
Cell[1923, 59, 66, 0, 31, "Text"],
Cell[1992, 61, 30, 0, 31, "Text"],
Cell[2025, 63, 49, 0, 31, "Text"],
Cell[2077, 65, 35, 0, 31, "Text"],
Cell[2115, 67, 57, 0, 31, "Text"],
Cell[2175, 69, 365, 11, 184, "Text"],
Cell[2543, 82, 469, 11, 167, "Text"],

Cell[CellGroupData[{
Cell[3037, 97, 30, 0, 42, "Subsubsection"],
Cell[3070, 99, 596, 11, 187, "Input"],
Cell[3669, 112, 99, 2, 27, "Input",
  InitializationCell->True],
Cell[3771, 116, 168, 5, 82, "Text"],
Cell[3942, 123, 86, 2, 27, "Input",
  InitializationCell->True],
Cell[4031, 127, 69, 1, 27, "Input"],
Cell[4103, 130, 67, 1, 27, "Input"],
Cell[4173, 133, 413, 6, 91, "Input"],
Cell[4589, 141, 210, 3, 43, "Input"],
Cell[4802, 146, 145, 3, 27, "Input",
  InitializationCell->True],
Cell[4950, 151, 100, 2, 27, "Input",
  InitializationCell->True],
Cell[5053, 155, 104, 2, 27, "Input",
  InitializationCell->True],
Cell[5160, 159, 104, 2, 27, "Input",
  InitializationCell->True],
Cell[5267, 163, 105, 2, 27, "Input",
  InitializationCell->True],
Cell[5375, 167, 303, 5, 75, "Input",
  InitializationCell->True],
Cell[5681, 174, 99, 2, 27, "Input",
  InitializationCell->True],
Cell[5783, 178, 569, 8, 155, "Input",
  InitializationCell->True],
Cell[6355, 188, 155, 3, 27, "Input",
  InitializationCell->True],
Cell[6513, 193, 150, 3, 27, "Input",
  InitializationCell->True],
Cell[6666, 198, 274, 4, 75, "Input",
  InitializationCell->True],
Cell[6943, 204, 802, 11, 187, "Input",
  InitializationCell->True],
Cell[7748, 217, 108, 2, 27, "Input",
  InitializationCell->True],
Cell[7859, 221, 114, 2, 27, "Input",
  InitializationCell->True],
Cell[7976, 225, 116, 2, 27, "Input",
  InitializationCell->True],
Cell[8095, 229, 113, 2, 27, "Input",
  InitializationCell->True],
Cell[8211, 233, 197, 3, 59, "Input",
  InitializationCell->True],
Cell[8411, 238, 216, 4, 59, "Input",
  InitializationCell->True],
Cell[8630, 244, 299, 5, 75, "Input",
  InitializationCell->True],
Cell[8932, 251, 88, 2, 27, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[9057, 258, 31, 0, 42, "Subsubsection"],
Cell[9091, 260, 818, 14, 185, "Text"],
Cell[9912, 276, 1126, 17, 219, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[11075, 298, 36, 0, 42, "Subsubsection"],
Cell[11114, 300, 620, 14, 171, "Input",
  InitializationCell->True],
Cell[11737, 316, 188, 4, 27, "Input",
  InitializationCell->True],
Cell[11928, 322, 195, 4, 43, "Input",
  InitializationCell->True],
Cell[12126, 328, 209, 4, 59, "Input",
  InitializationCell->True],
Cell[12338, 334, 145, 3, 27, "Input",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[12520, 342, 47, 0, 42, "Subsubsection"],
Cell[12570, 344, 647, 12, 139, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[13242, 360, 249, 4, 59, "Input"],
Cell[13494, 366, 133, 2, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[13676, 374, 45, 0, 42, "Subsubsection"],
Cell[13724, 376, 491, 10, 203, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[14252, 391, 45, 0, 42, "Subsubsection"],
Cell[14300, 393, 186, 4, 65, "Text"],
Cell[14489, 399, 156, 3, 27, "Input",
  InitializationCell->True],
Cell[14648, 404, 3287, 59, 843, "Input",
  InitializationCell->True],
Cell[17938, 465, 52, 1, 27, "Input"],
Cell[17993, 468, 43, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[18061, 473, 753, 11, 139, "Input"],
Cell[18817, 486, 404, 6, 65, "Output"]
}, Open  ]],
Cell[19236, 495, 112, 2, 27, "Input"],
Cell[19351, 499, 73, 0, 31, "Text"],
Cell[19427, 501, 753, 11, 123, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[20217, 517, 60, 0, 42, "Subsubsection"],
Cell[20280, 519, 723, 15, 235, "Text"],
Cell[21006, 536, 32, 0, 31, "Text"],
Cell[21041, 538, 167, 4, 48, "Text"],
Cell[21211, 544, 70, 1, 27, "Input"],
Cell[21284, 547, 68, 1, 27, "Input"],
Cell[21355, 550, 60, 1, 27, "Input"],
Cell[21418, 553, 127, 2, 27, "Input"],

Cell[CellGroupData[{
Cell[21570, 559, 73, 1, 27, "Input"],
Cell[21646, 562, 42, 1, 27, "Output"]
}, Open  ]],
Cell[21703, 566, 91, 3, 31, "Text"],
Cell[21797, 571, 294, 5, 65, "Text"],
Cell[22094, 578, 34, 0, 31, "Text"],
Cell[22131, 580, 91, 3, 31, "Text"],
Cell[22225, 585, 373, 6, 59, "Input",
  InitializationCell->True],
Cell[22601, 593, 25367, 448, 5483, "Input",
  InitializationCell->True],
Cell[47971, 1043, 156, 5, 82, "Text"],
Cell[48130, 1050, 356, 7, 91, "Input"],
Cell[48489, 1059, 369, 8, 99, "Text"],

Cell[CellGroupData[{
Cell[48883, 1071, 59, 1, 27, "Input"],
Cell[48945, 1074, 92, 1, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[49086, 1081, 41, 0, 42, "Subsubsection"],
Cell[49130, 1083, 389, 8, 91, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[49556, 1096, 39, 0, 42, "Subsubsection"],
Cell[49598, 1098, 42, 0, 31, "Text"],
Cell[49643, 1100, 1935, 34, 523, "Input",
  InitializationCell->True],
Cell[51581, 1136, 63, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[51669, 1141, 54, 1, 27, "Input"],
Cell[51726, 1144, 54, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[51817, 1150, 55, 1, 27, "Input"],
Cell[51875, 1153, 45, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[51957, 1159, 63, 1, 27, "Input"],
Cell[52023, 1162, 38, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[52098, 1168, 72, 1, 27, "Input"],
Cell[52173, 1171, 78, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[52288, 1177, 130, 2, 27, "Input"],
Cell[52421, 1181, 230, 8, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[52688, 1194, 130, 2, 27, "Input"],
Cell[52821, 1198, 238, 8, 44, "Output"]
}, Open  ]],
Cell[53074, 1209, 47, 1, 27, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[53158, 1215, 36, 0, 42, "Subsubsection"],
Cell[53197, 1217, 71, 2, 27, "Input",
  InitializationCell->True],
Cell[53271, 1221, 110, 3, 27, "Input",
  InitializationCell->True,
  CellTags->"(lic2) In[270]:="],
Cell[53384, 1226, 62, 1, 27, "Input"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

