(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     69376,       2169]*)
(*NotebookOutlinePosition[     70148,       2197]*)
(*  CellTagsIndexPosition[     70104,       2193]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Package Info", "Subsubsection"],

Cell[":Name: jutils`", "Text"],

Cell[":Context: jutils`", "Text"],

Cell[":Title: jutils miscellaneous functions", "Text"],

Cell["\<\
:Summary:
\tthese are just functions i personally use
\tnot necessarily meant to be libraried

\tsee changelog of PeriodicTables, few
\t
\tsee Warnings about CreateModule if used\
\>", "Text"],

Cell[":Author: John D. Hendrickson", "Text"],

Cell[":Mathematica Version 4.0", "Text"],

Cell[":Package Version: 1.0.4", "Text"],

Cell[":History:", "Text"],

Cell[":Keywords:", "Text"],

Cell["\<\
:Requirements: should be none.  has Needs but should be same all mm \
ver.\
\>", "Text"],

Cell[":Copyright: public domain", "Text"],

Cell["\<\
:Warnings:
\tCreateModule is a nice conept but...
\tI'm unsure if it has effects on front-end
\t\tit could cause problems saving but i
\t\tbelieve not.  but save your work until
\t\tyou are comfortable with it.
\tI'm doubly unsure if mm v.9 apache stuff works
\tenough the same.\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["Package and Setup Notes", "Subsubsection"],

Cell["Opening project , Avoiding direcory , currnt project dir.", "Text"],

Cell["<< jutils`", "Text"],

Cell[TextData[{
  "If .nb files move around in OS direcories any directory names in notebooks \
break.  ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " Directory[] tools are a nuisance to fix such dependancies.  the above was \
suggested to me and works great: shouldn't need any use of ln(1) to find \
init.m"
}], "Text"],

Cell["\<\
# ln -s ~/jutils/Documentation/English/jutils.help.nb to :
~/.Mathematica/4.0/AddOns/Applications/jutils/Documentation/English/jutils.\
help.nb\
\>", "Text"],

Cell["\<\
is created below and place automatically (see Private) but unlikely \
to be sucessful (you have to change directory but i won't symbolize it)

browsercategory >> \"~/jutils/BrowserCategories.m\";
browsercategory >> \
\"~/.Mathematica/4.0/AddOns/Applications/jutils/Documentation/English/\
BrowserCategories.m\";\
\>", "Text"],

Cell["\<\
# ln -s \
~/.Mathematica/4.0/AddOns/Applications/jutils/Documentation/English/\
BrowserCategories.m\
\>", "Text"],

Cell["\<\
ln init.m can be to \
~/.Mathematica/4.0/AddOns/Applications/jutils/init.m\
\>", "Text"],

Cell["\<\
Convenient is a mm palette you don't want.

Place this so palette could just as well launch jutils` (or use menu to add \
it as palette)
\t{~/.Mathematica/4.0/FrontEnd/Palettes/Convenient.nb}\t\
\>", "Text"],

Cell["\<\
fyi, $Path is search path which can be changed to include whatever \
the current project (area) is.\
\>", "Text"],

Cell["\<\
$Path=Union[{$HomeDirectory<>\"/math/Mathematica/chem\"},$Path];\
\>\
", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["IMPORTANT NOTE", "Subsubsection"],

Cell["\<\
mathematica 4.0 will slowly corrupt the save of an.nb that also \
saves as.m (use of save as special \"package format\") if the following is \
not done :\
\>", "Text"],

Cell["\<\
mathematica treats .nb that get saved as package specially
\t* remember to \"delete all output\" from kernel menu
\t* cells with tags \"(local) In[xxx]:\" need to be bumped so the tag \
disappears
\t  (bump: insert a return then delete it and tags will dissapear)
\t* insure init code is marked as \"initialization cell\" and that nothing
\t  else is marked as evaluatable which should not be\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["Package jutils", "Title"],

Cell[CellGroupData[{

Cell["Needs", "Subsection"],

Cell["local needs", "Text"],

Cell["Needs[\"Months`\"];", "Text",
  InitializationCell->True],

Cell["Needs[\"Miscellaneous`Calendar`\"];", "Text",
  InitializationCell->True],

Cell["\<\
DeclarePackage[\"Utilities`Package`\",{\"FindPackages\",\"\
Annotation\"}];\
\>", "Text"],

Cell[TextData[{
  StyleBox["DeclarePackage[\"", "MR"],
  StyleBox["context", "TI"],
  StyleBox["`\",", "MR"],
  " ",
  Cell[BoxData[
      \(TraditionalForm\`{\)], "InlineFormula"],
  StyleBox["\"", "MR"],
  Cell[BoxData[
      FormBox[
        SubscriptBox["\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"name\\\\\\\"\\\", \
\\\"TI\\\"]\\)\"\>", "1"], TraditionalForm]], "InlineFormula"],
  StyleBox["\",", "MR"],
  " ",
  StyleBox["\"", "MR"],
  Cell[BoxData[
      FormBox[
        SubscriptBox["\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"name\\\\\\\"\\\", \
\\\"TI\\\"]\\)\"\>", "2"], TraditionalForm]], "InlineFormula"],
  StyleBox["\",", "MR"],
  " \[Ellipsis] ",
  Cell[BoxData[
      \(TraditionalForm\`}\)], "InlineFormula"],
  StyleBox["]\n\t", "MR"],
  "loads pkg if name is ever incurred , also Stub attrib on name can do this"
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["BeginPackage", "Subtitle"],

Cell[BoxData[
    \(\(BeginPackage["\<jutils`\>"];\)\)], "Input",
  InitializationCell->True],

Cell[CellGroupData[{

Cell["Mesages", "Subsection"],

Cell[BoxData[
    \(\(Off[General::"\<spell\>"];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(jutils::"\<usage\>" = "\<some utils\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(true::usage = "\<True\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(false::usage = "\<True\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(groupadjacent::usage = "\<Splits list into groups using adjacency and \
rule given by arguments testeach and testboth.\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(CreateModule::usage = "\<CreateModule[f[x_], body, opts] assigns \
function definition for f to body collected by CombinCells.  See \
Help.\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(CombineCells::usage = "\<CombineCells[opts] combines cells found \
between last two text lines that text BoundryCell is found.  See \
Help.\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(Runto::usage = "\<RunTo[opts] runs from text line RunToBoundryCell is \
found on to current line.  See Help.\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(padit::usage = "\<padit[str,n] makes str width n by padding or \
removing on right.\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(paditl::usage = "\<padit[str,n] makes str width n by padding or \
removing on left.\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(paditc::usage = "\<paditc[str,n] centers string within greater width \
n.  ignores spaces given in str as intended.  unlike padit will not chop str.\
\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(ToEach::usage = "\<ToEach[a,b] is a list of  each a in with \
b\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(ToEach2::usage = "\<ToEach[a,b] is a list of  each a in with \
b\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(ToEach3::usage = "\<ToEach[a,b] is a list of  each a in with \
b\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(list::usage = "\<list[f,i] makes fun listable for i\>";\)\)], "Input",\

  InitializationCell->True],

Cell[BoxData[
    \(\(listc::usage = "\<listc[f,i] lists fun against all names in context \
i.\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(jm::usage = "\<jr[m_:0] returns to a cell jm[] marked.\>";\)\)], \
"Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(jmark;\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(jm::usage = "\<jm[m_:0] marks a cell (jr[] returns to it)\>";\)\)], \
"Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(jr::usage = "\<jm[m_:0] marks a cell (jr[] returns to it)\>";\)\)], \
"Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(NbOpenAsk::usage = "\<Opens nb using file dialog box.\>";\)\)], \
"Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(NbAsk::usage = "\<File Dialog tool: Fsb, NbOpenAsk\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(Fsb::usage = "\<Opens file dialog, returns string to \
stdout.\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(ucc::usage = "\<rsh cmd output is /tmp/nbasktmpfile\>";\)\)], "Input",\

  InitializationCell->True],

Cell[BoxData[
    \(\(ucl::usage = "\<run cmd and ReadList output\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(uci::usage = "\<run cmd and Import output\>";\)\)], "Input",
  InitializationCell->True],

Cell["are in Months", "Text"],

Cell[BoxData[
    \(\(IncrementToward::usage = "\<IncrementToward[y,x] increments x toward \
y in either direction.\>";\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(IncrementAway::usage = "\<IncrementAway[y,x] increments x away from y \
in either direction.\>";\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(IncrementAwayAbove::usage = "\<IncrementAwayAbove[y,x] increments x \
away from y going above if a direction must first be chosen.\>";\)\)], "Input",\

  Evaluatable->False],

Cell[BoxData[
    \(\(IncrementAwayBelow::usage = "\<IncrementAwayBelow[y,x] increments x \
away from y going below if a direction must first be chosen.\>";\)\)], "Input",\

  Evaluatable->False],

Cell[BoxData[
    \(\(mag::usage = "\<vector magnitude\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(unit::usage = "\<vector unitary\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(midpt::usage = "\<vector midpt\>";\)\)], "Input",
  InitializationCell->True],

Cell[CellGroupData[{

Cell["convenient - conv`", "Subsubsection"],

Cell["excuse, for personal launch palette", "Text"],

Cell[BoxData[
    \(\(Begin["\<conv`\>"];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(conv`jutilnb := NotebookOpen["\<~/jutils/jutils.nb\>"];\)\)], "Input",\

  InitializationCell->True],

Cell[BoxData[
    \(\(conv`jhelpnb := 
        NotebookOpen["\<~/jutils/Documentation/English/jutils.help.nb\>"];\)\)\
], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(conv`convnb := 
        NotebookOpen["\<~/math/Mathematica/Palettes/Convenient-nb.nb\>"];\)\)]\
, "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(End[];\)\)], "Input",
  InitializationCell->True],

Cell["\tgot out of conv`", "Text"],

Cell[BoxData[
    \(\(MUF = Miscellaneous`Units`Private`$ToFundamental;\)\)], "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Expr", "Subsection"],

Cell["\<\
note: these don't like being in a package (maybe it's just \
creatmodule but too hard to fix).  even the messages should be outside\
\>", \
"Text"],

Cell["\<\
createmodule can't be in private these are needed to resolve RunTo \
dependancy (i'm not sure runto must be outside of Private but the other two \
must be)\
\>", "Text"],

Cell[CellGroupData[{

Cell["true false", "Subsubsection"],

Cell[BoxData[
    \(\(true::usage = "\<True\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(false::usage = "\<False\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(true[__] := True;\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(false[__] := False;\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["groupadjacent", "Subsubsection"],

Cell["\<\
i wrote this because Split[] is broken - Splits' example for \
InputForm nubmer leeaves a \"-\" trailing at the end of digits , which is \
opposite what it says it will do.\
\>", "Text"],

Cell[BoxData[
    \(\(groupadjacent::usage = "\<Splits list into groups using adjacency and \
rule given by arguments testeach and testboth.\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(groupadjacent[v_List, testboth_, testeach_:  SameQ] := 
      Module[{i, j, n, v2, f}, \[IndentingNewLine]v2 = {}; n = Length[v]; 
        j = 1; \[IndentingNewLine]While[
          j \[LessEqual] n, \[IndentingNewLine]i = 
            j; \[IndentingNewLine]While[
            i < n\[IndentingNewLine] && 
              testeach[v[\([i]\)]]\[IndentingNewLine] && 
              testeach[v[\([i + 1]\)]]\[IndentingNewLine] && 
              testboth[v[\([i]\)]\[IndentingNewLine], 
                v[\([i + 1]\)]], \(++i\)]; \[IndentingNewLine]AppendTo[v2, 
            Take[v, {j, i}]]; \[IndentingNewLine]j = 
            i + 1\[IndentingNewLine]]; \[IndentingNewLine]v2\
\[IndentingNewLine]]\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["CreateModule", "Subsubsection"],

Cell["\<\
currently an issue is combining lines with comments interspersed \
with compound expressions\
\>", "Text"],

Cell["\<\
see below
\t(* data=body/.Cell[BoxData[x:__],__]\[Rule]x; *)
This expression becomes value of Global`x if x is defined (else it works).

Would like to know why.  I think it evaluates while pattern matching (in this \
case un-intended).  However that doesn't explain , in my mind , how Global`x \
is ever involved unless there is a problem outside this routine.\
\>", "Text"],

Cell[BoxData[
    \(\(Options[CreateModule] = {Vars \[Rule] Null, Context \[Rule] "\<\>", 
          Context2 \[Rule] "\<\>", Paste \[Rule] True};\)\)], "Input",
  InitializationCell->True],

Cell["was nb=SelectedNotebook[]; unsure why", "Text"],

Cell[BoxData[
    \(CreateModule[head_, body_, opts___] := 
      Module[{asf, x, i, mb, vb, mbvb, mbvbdata, context, context2, data, 
          cell, vars2, vars, con2, ra, rm, rh, r1, bd, 
          paste}, \[IndentingNewLine]asf = 
          AutoScroll \[Rule] 
            False; \[IndentingNewLine]vars = \(Vars /. {opts}\) /. 
            Options[CreateModule]; \[IndentingNewLine]context = \(Context /. \
{opts}\) /. Options[
              CreateModule]; \[IndentingNewLine]context2 = \(Context2 /. \
{opts}\) /. Options[
              CreateModule]; \[IndentingNewLine]paste = \(Paste /. {opts}\) /. 
            Options[CreateModule]; \[IndentingNewLine]If[vars === Null, 
          vars2 = Names[context <> "\<*\>"], 
          vars2 = vars]; \[IndentingNewLine]vb = 
          Insert[vars2, "\<,\>", 
            Table[{i}, {i, 2, 
                Length[vars2]}]]; \[IndentingNewLine] (*\ \(data = 
              body /. Cell[BoxData[x : __], __] \[Rule] 
                  x;\)\ *) \[IndentingNewLine]data = \
\(body[\([1]\)]\)[\([1]\)]; \  (*\ 
          should\ work\ for\ above\ *) \[IndentingNewLine]data = 
          data[\([1]\)]; \  (*\ outer\ wrap\ *) \[IndentingNewLine] (*\ 
          static\ form\ for\ module\ is\ picky\ and\ Eval\ freezes\ w/
              o\ *) \[IndentingNewLine] (*\ \(for\ that\ reason\  /. \ 
              has\ been\)\  /. \ for\ static\ *) \[IndentingNewLine]vb = 
          RowBox[Flatten[vb]]; \[IndentingNewLine]vb = 
          RowBox[{"\<{\>", vb, "\<}\>"}]; \[IndentingNewLine]ra = 
          Sequence[vb, "\<,\>", "\<\n\>", 
            Sequence @@ data]; \[IndentingNewLine] (*\ 
          note\ IndentingNewLine\ omitted\ after\ ra\ \
*) \[IndentingNewLine]rm = 
          RowBox[\ {"\<Module\>", \ "\<[\>"\ , \ 
              ra\ , \ "\<]\>"\ }]; \[IndentingNewLine]If[
          paste === True, \[IndentingNewLine]\(rh = 
              RowBox[{ToBoxes[head], "\<:=\>", 
                  rm}];\)\[IndentingNewLine], \(rh = 
              rm;\)\[IndentingNewLine]]; \[IndentingNewLine]r1 = 
          RowBox[{rh, "\<;\>"}]; \[IndentingNewLine]bd = 
          BoxData[r1]; \[IndentingNewLine] (*\ 
          Evaluatable \[Rule] 
            True\ prevents\ CellAutoOverwrite\ *) \[IndentingNewLine]cell = 
          Cell[bd, "\<Output\>", CellLabel \[Rule] "\<Gen Mod\>", 
            GeneratedCell \[Rule] True, 
            Evaluatable \[Rule] False]; \[IndentingNewLine]If[
          paste === True || paste === Safe, \[IndentingNewLine]nb = 
            EvaluationNotebook[]; \[IndentingNewLine]SelectionMove[nb, After, 
            EvaluationCell, asf]; \[IndentingNewLine]NotebookWrite[nb, 
            cell]; \[IndentingNewLine]If[paste === Safe, 
            Return[]]; \[IndentingNewLine] (*\ 
            SelectionEvaluate[
                nb]\ does\ not\ post\ until\ after\ NotebookEvaluate\ no\ \
matter\ what\ is\ tried\ *) \[IndentingNewLine]SelectionMove[nb, Next, Cell, 
            asf]; \[IndentingNewLine]ToExpression[
            cell[\([1, 1]\)]];\[IndentingNewLine] (*\ \(SetOptions[
                NotebookSelection[nb], 
                Evaluatable \[Rule] False];\)\ *) \[IndentingNewLine], 
          cell\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["CombineCells", "Subsubsection"],

Cell[BoxData[
    \(\(Options[CombineCells] = {Paste \[Rule] False, 
          Begin \[Rule] "\<BoundryCell\>", \ End \[Rule] "\<BoundryCell\>", 
          Len \[Rule] 500, Direction \[Rule] \(-1\), 
          Skip \[Rule] True};\)\)], "Input",
  InitializationCell->True],

Cell["was nb=SelectedNotebook[];  unsure why", "Text"],

Cell[BoxData[
    \(\(CombineCells[opts___] := 
        Module[{data, data2, data3, asf, nb, str, done, begin, end, len, 
            before, previous, i, j, a, b, c, d, e, x, y, z, 
            skip}, \[IndentingNewLine]paste = \(Paste /. {opts}\) /. 
              Options[CombineCells]; \[IndentingNewLine]begin = \(Begin /. \
{opts}\) /. Options[
                CombineCells]; \[IndentingNewLine]end = \(End /. {opts}\) /. 
              Options[CombineCells]; \[IndentingNewLine]len = \(Len /. {opts}\
\) /. Options[
                CombineCells]; \[IndentingNewLine]dir = \(Direction /. {opts}\
\) /. Options[CombineCells]; \[IndentingNewLine]skip = \(Skip /. {opts}\) /. 
              Options[CombineCells]; \[IndentingNewLine]before = Before; 
          previous = Previous; \[IndentingNewLine]If[dir \[Equal] 1, 
            before = After; previous = Next]; \[IndentingNewLine]asf = 
            AutoScroll \[Rule] False; \[IndentingNewLine]done = False; 
          p1 = \(p2 = \(data4 = \(data3 = \(data2 = "\<\>"\)\)\)\); 
          data = {}; \[IndentingNewLine]nb = 
            EvaluationNotebook[]; \[IndentingNewLine]SelectionMove[nb, 
            before, EvaluationCell, asf]; \[IndentingNewLine]SelectionMove[
            nb, previous, Cell, asf]; \[IndentingNewLine]SelectionMove[nb, 
            All, CellContents, asf]; \[IndentingNewLine]data2 = 
            NotebookRead[nb]; \[IndentingNewLine]str = 
            ToString[data2]; \[IndentingNewLine]If[\ data2 =!= \ end, 
            Print["\<no end\>"]; Return[]]; \[IndentingNewLine]SelectionMove[
            nb, previous, Cell, asf]; \[IndentingNewLine]SelectionMove[nb, 
            All, CellContents, asf]; \[IndentingNewLine]i = 0; done = False; 
          data3 = \(data2 = "\<\>"\); 
          data = "\<\>"; \[IndentingNewLine]SelectionMove[nb, All, Cell, 
            asf]; \[IndentingNewLine]While[
            done === False\  && \(++i\) < 
                len, \[IndentingNewLine]\[IndentingNewLine]data3 = 
              NotebookRead[nb]; \[IndentingNewLine]data2 = 
              data3[\([1]\)]; \[IndentingNewLine]data3 = 
              Drop[data3, 1]; \[IndentingNewLine]\[IndentingNewLine]If[
              skip\  && \ Length[
                    Cases[data3, "\<Output\>" | "\<Print\>" | "\<Message\>"]] \
> 0, \[IndentingNewLine]SelectionMove[nb, previous, Cell, 
                
                asf]; \[IndentingNewLine]Continue[]\[IndentingNewLine]]; \
\[IndentingNewLine]\[IndentingNewLine]str = 
              ToString[data2]; \[IndentingNewLine]If[str === begin, 
              done = True, \[IndentingNewLine]j = 
                Length[data2]; \[IndentingNewLine]If[
                j > 0 || \[Not] skip, \[IndentingNewLine]If[
                  j > 0 && data2[\([0]\)] == BoxData, 
                  data2 = data2[\([1]\)]]; \[IndentingNewLine]If[
                  Length[Position[data2, RowBox]] > 1, 
                  data2 = data2[\([1]\)]]; \[IndentingNewLine]data3 = 
                  data2 /. \[InvisibleSpace]\[IndentingNewLine]{a : ___, 
                        RowBox[{RowBox[{b : ___}], h : ___, x : "\<;\>", 
                            d : ___}], 
                        c : ___} \[Rule] \[IndentingNewLine]{a, RowBox[{b}], 
                        x, h, d, c}; \[IndentingNewLine]data2 = 
                  data3; \[IndentingNewLine]data\  = \ 
                  Sequence[data2, \ "\<\n\>", \ 
                    data];\[IndentingNewLine]]; \
\[IndentingNewLine]SelectionMove[nb, previous, Cell, 
                asf];\[IndentingNewLine]];\[IndentingNewLine]]; \
\[IndentingNewLine]data = 
            Flatten[Drop[List[data], \(-1\)]]; \[IndentingNewLine] (*\ 
            stripped\ each\ outer\ for\ ea\ above\ *) \[IndentingNewLine]data \
= RowBox[data]; \[IndentingNewLine]data = 
            Cell[BoxData[
                data], "\<Output\>"]; \[IndentingNewLine]SelectionMove[nb, 
            After, EvaluationCell, asf]; \[IndentingNewLine]If[
            done === False\ \ , Print["\<no begin\>"]; 
            Return[]]; \[IndentingNewLine]If[
            paste === True, \[IndentingNewLine]NotebookWrite[nb, 
              data]; \[IndentingNewLine]SelectionMove[nb, Previous, Cell, 
              asf]; \[IndentingNewLine]SelectionMove[nb, All, Cell, 
              asf]; \[IndentingNewLine]SetOptions[NotebookSelection[nb], 
              CellLabel \[Rule] "\<Gen Mod\>", GeneratedCell \[Rule] True, 
              Evaluatable \[Rule] False\ ]; \[IndentingNewLine]SelectionMove[
              nb, After, Cell, asf];\[IndentingNewLine], 
            data\[IndentingNewLine]]\[IndentingNewLine]];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["RunTo", "Subsubsection"],

Cell["\<\
really I'd rather use Input[ n - m ] however that won't work in \
many situations\
\>", "Text"],

Cell[BoxData[
    \(\(Options[RunTo] = {Paste \[Rule] False, 
          Begin \[Rule] "\<RunToBoundryCell\>", \ 
          End \[Rule] "\<RunToBoundryCell\>", Len \[Rule] 500, 
          Direction \[Rule] \(-1\), Skip \[Rule] True};\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(RunTo[opts___] := 
      Module[{data, data2, data3, asf, nb, str, done, begin, end, len, 
          before, previous, i, j, a, b, c, d, f, g, h, w, x, y, z, 
          skip}, \[IndentingNewLine]paste = \(Paste /. {opts}\) /. 
            Options[RunTo]; \[IndentingNewLine]begin = \(Begin /. {opts}\) /. 
            Options[RunTo]; \[IndentingNewLine]end = \(End /. {opts}\) /. 
            Options[RunTo]; \[IndentingNewLine]len = \(Len /. {opts}\) /. 
            Options[RunTo]; \[IndentingNewLine]dir = \(Direction /. {opts}\) /. 
            Options[RunTo]; \[IndentingNewLine]skip = \(Skip /. {opts}\) /. 
            Options[RunTo]; \[IndentingNewLine]before = Before; 
        previous = Previous; \[IndentingNewLine]If[dir \[Equal] 1, 
          before = After; previous = Next]; \[IndentingNewLine]asf = 
          AutoScroll \[Rule] False; \[IndentingNewLine]done = False; 
        p1 = \(p2 = \(data4 = \(data3 = \(data2 = "\<\>"\)\)\)\); 
        data = {}; \[IndentingNewLine]nb = 
          SelectedNotebook[]; \[IndentingNewLine]SelectionMove[nb, before, 
          EvaluationCell, asf]; \[IndentingNewLine]i = 0; done = False; 
        data3 = \(data2 = "\<\>"\); 
        data = "\<\>"; \[IndentingNewLine]SelectionMove[nb, previous, Cell, 
          asf]; \[IndentingNewLine] (*\ 
          scan\ back\ to\ Boundry\ *) \[IndentingNewLine]z = 
          0; \[IndentingNewLine]While[
          done === False\  && \(++i\) < len, \[IndentingNewLine]data3 = 
            NotebookRead[nb]; \[IndentingNewLine]data2 = 
            data3[\([1]\)]; \[IndentingNewLine]str = 
            ToString[data2]; \[IndentingNewLine]If[str === begin, 
            done = True\ ]; \[IndentingNewLine]If[
            Length[data3] > 1 && 
              StringMatchQ[
                ToString[
                  Rest[data3]], "\<*Input,*\>"], \(++z\)\ ]; \
\[IndentingNewLine]SelectionMove[nb, previous, Cell, 
            asf];\[IndentingNewLine]]; \[IndentingNewLine]SelectionMove[nb, 
          next, Cell, asf]; \[IndentingNewLine]SelectionMove[nb, next, Cell, 
          asf]; \[IndentingNewLine]data3 = 
          NotebookRead[nb]; \[IndentingNewLine]SelectionMove[nb, All, Cell, 
          asf]; \[IndentingNewLine] (*\ scan\ to\ start\ , \ 
          eval\ any\ Input\ cell\ *) \[IndentingNewLine]j = 0; a = 0; b = z; 
        c = 
          i; \[IndentingNewLine]While[\(++j\) < i && j < len && 
            a < z, \[IndentingNewLine]data3 = 
            NotebookRead[nb]; \[IndentingNewLine]If[
            Length[data3] > 1 && 
              StringMatchQ[
                ToString[First[data3]], \[IndentingNewLine]"\<*RunTo*\>"], 
            Print["\<stop: found RunTo before finish\>"]; 
            Break[]]; \[IndentingNewLine]If[
            Length[data3] > 1 && 
              StringMatchQ[
                ToString[
                  Rest[data3]], "\<*Input,*\>"], \
\[IndentingNewLine]SelectionEvaluate[nb, asf]; \[IndentingNewLine]If[
              a \[Equal] 0, 
              str = ToString[data3[\([3]\)]]]; \[IndentingNewLine]d = 
              ToString[
                data3[\([3]\)]]; \[IndentingNewLine]\(++a\); \
\[IndentingNewLine] (*\ 
              note\ selection\ auto\ moves\ past\ output\ \
*) \[IndentingNewLine] (*\ 
              note\ Evaluation\ cell\ is\ Runto\ still\ \
*) \[IndentingNewLine]]; \[IndentingNewLine]SelectionMove[nb, next, Cell, 
            asf];\[IndentingNewLine]]; \[IndentingNewLine]\[IndentingNewLine] \
(*\ are\ same\ but\ for\ practice\ sake\ *) \[IndentingNewLine]\
\[IndentingNewLine] (*\ \(w = 
              ToExpression[
                StringJoin[
                  Characters[
                      str] /. {___, a : _ /; a == "\<[\>", y : __, 
                        b : _ /; b == "\<]\>", ___} \[Rule] 
                      y]];\)\[IndentingNewLine]*) \[IndentingNewLine]\
\[IndentingNewLine]y = 
          ToExpression[
            StringJoin[\(groupadjacent[
                  Characters[
                    str], \((\((DigitQ[#1] && 
                            DigitQ[#2])\) || \((\[Not] DigitQ[#1] && \[Not] \
DigitQ[#2])\) &)\), 
                  true]\)[\([2]\)]]]; \[IndentingNewLine]\[IndentingNewLine]z \
= ToExpression[
            StringJoin[
              Select[Characters[d], 
                DigitQ]]]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
          see\ jutils\ tips\ above\ , \ 
          scan\ and\ Table\ would\ be\ ok\ *) \[IndentingNewLine]\
\[IndentingNewLine]\ 
        w = z - y; \[IndentingNewLine]g = $Line + 2; \ \[IndentingNewLine]\ 
        h = $Line + w + 
            1; \[IndentingNewLine]\[IndentingNewLine] (*\ \(forget\ using\ w\ \
 ... \)\ \[IndentingNewLine]\ for\ some\ reason\ front\ end\ doesn' 
            t\ sync\ In\ labels\ \ \[IndentingNewLine]\ 
            until\ after\ this\ module\ exits\ so\ no\ guess\ can\ work\
\[IndentingNewLine]*) \[IndentingNewLine]\[IndentingNewLine]SelectionMove[nb, 
          After, EvaluationCell]; \
\[IndentingNewLine]\[IndentingNewLine]"\<inputs seen back=\>" <> 
          ToString[b] <> "\< inputs exec'ed=\>" <> 
          ToString[a] <> "\< tot. lines=\>" <> 
          ToString[i] <> \ "\< old \>" <> "\< In[\>" <> 
          ToString[y] <> "\<] to In[\>" <> 
          ToString[z] <> "\<]\>"\  <> "\< guessing \>" <> "\< In[\>" <> 
          ToString[g] <> "\<] to In[\>" <> 
          ToString[
            h] <> "\<]\>"\[IndentingNewLine]\[IndentingNewLine]]\)], "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Private", "Subsubtitle"],

Cell[BoxData[
    \(\(Begin["\<`Private`\>"];\)\)], "Input",
  InitializationCell->True],

Cell[CellGroupData[{

Cell["Expr", "Subsection"],

Cell[CellGroupData[{

Cell["padit", "Subsubsection"],

Cell[BoxData[
    \(padit[v_, pad_] := 
      StringJoin[PadRight[Characters[ToString[v]], pad, "\< \>"]]\)], "Input",\

  InitializationCell->True],

Cell[BoxData[
    \(paditl[v_, pad_] := 
      StringJoin[PadLeft[Characters[ToString[v]], pad, "\< \>"]]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(paditc[v_, pad_] := 
      Module[{si, sf, n, m}, \[IndentingNewLine]n = 
          pad + 1; \[IndentingNewLine]si = v; \[IndentingNewLine]m = 
          StringLength[
            si]; \[IndentingNewLine]While[\(--n\) \[GreaterEqual] 1 && 
            m < pad, \[IndentingNewLine]m = m + 1; \[IndentingNewLine]sf = 
            padit[si, m]; \[IndentingNewLine]m = m + 1; \[IndentingNewLine]If[
            m > pad, Return[sf]]; \[IndentingNewLine]If[sf != si, 
            si = paditl[sf, m]]; \[IndentingNewLine]If[sf === si, m = pad, 
            m = StringLength[
                si]];\[IndentingNewLine]]; \[IndentingNewLine]si\
\[IndentingNewLine]]\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["ToEach", "Subsubsection"],

Cell["(* SetAttributes[ToEach2,HoldRest] *)", "Text"],

Cell[BoxData[
    \(ToEach2[a_, b_] := 
      Module[{i}, 
        Table[{a[\([i]\)], Evaluate[b]}, {i, 1, Length[a]}]]\)], "Input",
  InitializationCell->True],

Cell["(* SetAttributes[ToEach3,HoldRest] *)", "Text"],

Cell[BoxData[
    \(ToEach3[a_, b_] := \[IndentingNewLine]Module[{v}, 
        a + v /. {Plus \[Rule] List, v -> b}]\)], "Input",
  InitializationCell->True],

Cell["(* SetAttributes[ToEach,HoldRest] *)", "Text"],

Cell[BoxData[
    \(ToEach[a_, b_] := Map[\ \(({#, b} &)\), a]\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["list", "Subsubsection"],

Cell[BoxData[
    \(\(SetAttributes[{list, listc}, Listable];\)\)], "Input",
  InitializationCell->True],

Cell["Use [any] function as Listable", "Text"],

Cell[BoxData[
    \(\(list[ff_Symbol, i_] := ff[i];\)\)], "Input",
  InitializationCell->True],

Cell["example , map vars to fun print", "Text"],

Cell[BoxData[
    \( (*\ vars = {"\<i\>", "\<j\>", "\<ffun\>", "\<fdo\>"}\ *) \)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \( (*\ list[Print, vars]\ *) \)], "Input",
  Evaluatable->False],

Cell["example , apply against vars in context", "Text"],

Cell[BoxData[
    \( (*\ \(OLD\ ?\ listc[ff_Symbol, str_String] := 
          list[Evaluate[Names[str]], ff];\)\ *) \)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(listc[ff_Symbol, str_String] := 
        list[ff, Evaluate[Names[str]]];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \( (*\ listc[Print, "\<Global`*\>"]\ *) \)], "Input",
  Evaluatable->False],

Cell["listc is very similar to", "Text"],

Cell[BoxData[
    \( (*\ Map[Print, Names["\<Global`*\>"]]\ *) \)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["jr", "Subsubsection"],

Cell[BoxData[
    \(\(jr[m_:  0] := 
        Module[{a, b, c, data, asf, nb, where}, \[IndentingNewLine]asf = 
            AutoScroll \[Rule] False; 
          where = 0; \[IndentingNewLine]If[IntegerQ[jmark] === False, 
            jmark = 1]; \[IndentingNewLine]If[m =!= 0, where = m, 
            where = jmark]; \[IndentingNewLine]If[where \[Equal] 0, 
            Print["\<where?\>"]; Return[]]; \[IndentingNewLine]nb = 
            SelectedNotebook[]; \[IndentingNewLine]SelectionMove[nb, 
            Previous, EvaluationCell, asf]; \[IndentingNewLine]SelectionMove[
            nb, All, CellContents, asf]; \[IndentingNewLine]SelectionMove[nb, 
            All, Word, asf]; \[IndentingNewLine]data = 
            NotebookRead[nb]; \[IndentingNewLine]If[
            data /. BoxData[x : _] \[Rule] 
                x\  \[Equal] "\<jr\>", \[IndentingNewLine]SelectionMove[nb, 
              All, Cell, asf]; \[IndentingNewLine]NotebookDelete[
              nb]; \[IndentingNewLine]NotebookLocate[
              ToString[where]];\[IndentingNewLine]];];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["jm", "Subsubsection"],

Cell[BoxData[
    \(\(jm[m_:  0] := 
        Module[{a, b, c, data, asf, nb, where}, \[IndentingNewLine]asf = 
            AutoScroll \[Rule] False; \[IndentingNewLine]If[
            IntegerQ[jmark] === False, jmark = 0]; \[IndentingNewLine]If[
            m =!= 0, where = m, \(++jmark\); 
            where = jmark]; \[IndentingNewLine]nb = 
            SelectedNotebook[]; \[IndentingNewLine] (*\ 
            pt . \ after\ output\ cell\ *) \[IndentingNewLine]SelectionMove[
            nb, After, EvaluationCell, asf]; \[IndentingNewLine]SelectionMove[
            nb, Next, Cell, asf]; \[IndentingNewLine]SelectionMove[nb, All, 
            Cell, asf]; \[IndentingNewLine]data = 
            NotebookRead[nb]; \[IndentingNewLine] (*\ 
            note\ use\  -> \ \(\(not\)\(\ \)\(\[Rule]\)\)\ \
*) \[IndentingNewLine]c = 
            ToExpression["\<CellTags->\"\>" <> 
                ToString[where] <> "\<\"\>"]; \[IndentingNewLine]data2 = 
            data /. Cell[a : __, b : _] \[Rule] 
                Cell[a, b, c]; \[IndentingNewLine]NotebookWrite[nb, 
            data2]; \ \[IndentingNewLine] (*\ 
            normal\ placement\ *) \[IndentingNewLine] (*\ \(SelectionMove[nb, 
                After, EvaluationCell];\)*) \[IndentingNewLine]SelectionMove[
            nb, Previous, EvaluationCell, 
            asf]; \[IndentingNewLine]SelectionMove[nb, All, CellContents, 
            asf]; \[IndentingNewLine]SelectionMove[nb, All, Word, 
            asf]; \[IndentingNewLine]data = 
            NotebookRead[nb]; \[IndentingNewLine]If[
            data /. BoxData[x : _] \[Rule] 
                x\  \[Equal] "\<jm\>", \[IndentingNewLine]SelectionMove[nb, 
              All, Cell, asf]; \[IndentingNewLine]NotebookDelete[
              nb];\[IndentingNewLine]];];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Fsb", "Subsubsection"],

Cell["\tfor use with src/openMotif-n.n.n/demos/programs/fsb", "Text"],

Cell[BoxData[
    \(\(Fsb::usage = "\<Opens file dialog, returns string to \
stdout.\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(ucc::usage = "\<rsh cmd output is /tmp/nbasktmpfile\>";\)\)], "Input",\

  InitializationCell->True],

Cell[BoxData[
    \(\(ucl::usage = "\<run cmd and ReadList output\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(uci::usage = "\<run cmd and Import output\>";\)\)], "Input",
  InitializationCell->True],

Cell["\<\
Fsb offers a \"safe replacement\" for opening files since \
\"File->Open\" filebox freezes front end for any wrong keystroke.\
\>", "Text"],

Cell["\<\
Fsb is to replace broken file box.  after error it ? drops stream \
(freezes) they said,  anywhow the box motif box isn't modal (can be hidden) \
but gets hidden and thus invisible and without input : thus mathematica is \
frozen waiting for input you cna't give it.  (all you see is the cursor , the \
box is actually still waiting for key)\
\>", "Text"],

Cell["\<\
there is some way to pass key to the hidden box i can't remember \
how at the moment\
\>", "Text"],

Cell[BoxData[
    \(Fsb[] := 
      Module[{xfile, str, 
          cmd}, \[IndentingNewLine]Run["\<echo \\\"$(fsb)\\\" > \
/tmp/nbasktmpfile\>"]; \[IndentingNewLine]xfile = 
          OpenRead["\</tmp/nbasktmpfile\>"]; \[IndentingNewLine]str = 
          Read[xfile]; Close[xfile]; str]\)], "Input",
  InitializationCell->True],

Cell["\<\
good news of OpenRead is it can Read n and Skip n and Close.  bad \
and good: it's baked.  experimental has binary.\
\>", "Text"],

Cell["\<\
more wack is \"RunThrough\" which refuses ? non-expressions as \
output but (won't) evalutate output that is expression\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["ucc", "Subsubsection"],

Cell[TextData[{
  "Is nice if one doesn't need to switch to xterm to create a file and switch \
back to ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " to read / show it.  With baked input and owned tty - not straight away."
}], "Text"],

Cell[BoxData[
    \(\(ucc[c_String, 
          host_String:  $MachineName] := \[IndentingNewLine]Module[{file, 
            cmd}, \[IndentingNewLine]file = "\</tmp/nbasktmpfile\>"; \
\[IndentingNewLine]cmd = "\<rsh \>" <> 
              host\  <> "\< '(\>" <> "\<. /etc/profile.small ; \>" <> 
              c <> "\< 2>>/dev/null > \>"\  <> \ 
              file <> "\<)'\>"; \[IndentingNewLine]Run[cmd]];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["ucl", "Subsubsection"],

Cell[BoxData[
    \(ucl[c_String, 
        host_String:  $MachineName] := \[IndentingNewLine]Module[{xfile, str, 
          file}, \[IndentingNewLine]file = "\</tmp/nbasktmpfile\>"; \
\[IndentingNewLine]ucc[c, host]; \[IndentingNewLine]xfile = 
          OpenRead[file]; \[IndentingNewLine]str = ReadList[xfile, String]; 
        Close[xfile]; \[IndentingNewLine]str]\)], "Input",
  InitializationCell->True],

Cell["\<\
ucl[c_String,host_String:\"sol8\"]:=Module[{xfile,str,file,cmd},
    file=\"/tmp/nbasktmpfile\";
    cmd=c<>\" > \" <> file;
    Run[cmd];
    xfile=OpenRead[file];
    str=ReadList[xfile,String];Close[xfile];
    (*DeleteFile[file];*)
    str]\
\>", "Text"],

Cell["skip DeleteFile[file]", "Text"],

Cell["Streams[]", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["uci", "Subsubsection"],

Cell[BoxData[
    \(uci[c_String, host_:  $MachineName] := 
      Module[{file}, \[IndentingNewLine]file = "\</tmp/nbasktmpfile\>"; \
\[IndentingNewLine]ucc[c, host]; Import[file, "\<Text\>"]]\)], "Input",
  InitializationCell->True],

Cell["\<\
examples:
\tuci[\"man -P cat cal\"]
\tucl[\"ls | cols -w 25 -c 2\"]\
\>", "Text"],

Cell["\<\
uci[c_String,host_String:\"sol8\"]:=Module[{str,file,cmd},
    file=\"/tmp/nbasktmpfile\";
    cmd=c<>\" 2>>/dev/null > \" <> file;
    Run[cmd];Import[file,\"Text\"]]\
\>", "Text"],

Cell["\<\
cmd=\"/bin/bash -l -c '(. /etc/profile ; man -P cat cal 2>&1 > \
nbasktmpfile 2>&1)'\"\
\>", "Text"],

Cell["\<\
with above simple cmd, \"man -P cat cal\"  cannot run gzip likely \
as mathematica or shell it started from owns /dev/pty stdout and stderr , and \
no easy command , \"due to tty improvements makeing tty no longer a file\" , \
can attatch.  rsh(1) does it.\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["NbAskOpen", "Subsubsection"],

Cell["(*\"\" opens an empty notebook*)", "Text"],

Cell[BoxData[
    \(NbOpenAsk[] := 
      Module[{xfile}, 
        xfile = Fsb[]; \[IndentingNewLine]If[xfile \[NotEqual] "\<\>", 
          NotebookOpen[xfile], $Failed]]\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Increments", "Subsubsection"],

Cell["\<\
incase calendar didn't load ...\[Not]NameQ[\"IncrementToward\"] is \
a pain\
\>", "Text"],

Cell[BoxData[
    \(IncrementToward[y_, x_] := 
      If[\((y >= 0 && x > y)\) || \((y <= 0 && x > y)\), 
        x - 1, \[IndentingNewLine]If[x =!= y, x + 1, 
          x]\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(IncrementAway[y_, x_] := 
      If[\((y >= 0 && x > y)\) || \((y <= 0 && x > y)\), 
        x + 1, \[IndentingNewLine]If[x =!= y, x - 1, 
          x + Sign[x]]\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(IncrementAwayAbove[y_, x_] := 
      If[\((y >= 0 && x > y)\) || \((y <= 0 && x > y)\), 
        x + 1, \[IndentingNewLine]If[x =!= y, x - 1, 
          x + 1]\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(IncrementAwayBelow[y_, x_] := 
      If[\((y >= 0 && x > y)\) || \((y <= 0 && x > y)\), 
        x + 1, \[IndentingNewLine]If[x =!= y, x - 1, 
          x - 1]\[IndentingNewLine]]\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["mag", "Subsubsection"],

Cell[BoxData[
    \(\(mag[r_] := \((Plus @@ \((r^2)\))\)^\((1/2)\);\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["unit", "Subsubsection"],

Cell[BoxData[
    \(\(unit[r_] := 
        Module[{mr}, mr = mag[r]; \ If[mr === 0, 0, r/mr]];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["midpt", "Subsubsection"],

Cell[BoxData[
    \(\(midpt[r_] := 
        Module[{mr}, lr = Length@r; \ 
          If[lr === 0, 0, Plus @@ \((r)\)/lr]];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["BrowserCategory", "Subsubsection"],

Cell["Browser Categories", "Text"],

Cell["\<\
note after evaluating, if saving, \"bump\" (use enter) the cell to \
get rid of the cell tag before saving (see notes at top)\
\>", "Text"],

Cell["\<\
save this as 
\t~/.Mathematica/4.0/AddOns/Applications/jutils/Documentation/English
unsure if .nb can be pointed outside\
\>", "Text"],

Cell[BoxData[
    \(\(\( (*\ 
      written\ \(by : \ 
          was - help . 
                nb\ in\ \(\(chem\)\(/\)\)\)\ \
*) \)\(\[IndentingNewLine]\)\(browsercategory = 
        BrowserCategory[\[IndentingNewLine]\[IndentingNewLine]"\<jutils\>"\
\[IndentingNewLine], 
          None\[IndentingNewLine], \
{\[IndentingNewLine]\[IndentingNewLine]Item[\[IndentingNewLine]"\<Top\>"\
\[IndentingNewLine], "\<jutils.help.nb\>"\[IndentingNewLine], 
              CopyTag \[Rule] "\<S1.0.0\>"\[IndentingNewLine], 
              IndexTag \[Rule] "\<1.1\>"\[IndentingNewLine]]\
\[IndentingNewLine]\[IndentingNewLine], 
            Item[\[IndentingNewLine]"\<jm / jr\>"\[IndentingNewLine], \
"\<jutils.help.nb\>"\[IndentingNewLine], 
              CopyTag \[Rule] "\<S1.1.1\>"\[IndentingNewLine], 
              IndexTag \[Rule] "\<1.1\>"\[IndentingNewLine]]\
\[IndentingNewLine]\[IndentingNewLine], 
            Item[\[IndentingNewLine]"\<mod v. pack\>"\[IndentingNewLine], \
"\<jutils.help.nb\>"\[IndentingNewLine], 
              CopyTag \[Rule] "\<S1.2.1\>"\[IndentingNewLine], 
              IndexTag \[Rule] "\<1.1\>"\[IndentingNewLine]]\
\[IndentingNewLine]\[IndentingNewLine], 
            Item[\[IndentingNewLine]"\<symbolics\>"\[IndentingNewLine], \
"\<jutils.help.nb\>"\[IndentingNewLine], 
              CopyTag \[Rule] "\<S1.3.1\>"\[IndentingNewLine], 
              IndexTag \[Rule] "\<1.1\>"\[IndentingNewLine]]\
\[IndentingNewLine]\[IndentingNewLine], 
            Item[\[IndentingNewLine]"\<CreateModule\>"\[IndentingNewLine], \
"\<jutils.help.nb\>"\[IndentingNewLine], 
              CopyTag \[Rule] "\<S1.4.1\>"\[IndentingNewLine], 
              IndexTag \[Rule] "\<1.1\>"\[IndentingNewLine]]\
\[IndentingNewLine]\[IndentingNewLine], 
            Item[\[IndentingNewLine]"\<RunTo\>"\[IndentingNewLine], \
"\<jutils.help.nb\>"\[IndentingNewLine], 
              CopyTag \[Rule] "\<S1.4.2\>"\[IndentingNewLine], 
              IndexTag \[Rule] "\<1.1\>"\[IndentingNewLine]]\
\[IndentingNewLine]\[IndentingNewLine], 
            Item[\[IndentingNewLine]"\<CombineCells\>"\[IndentingNewLine], \
"\<jutils.help.nb\>"\[IndentingNewLine], 
              CopyTag \[Rule] "\<S1.5.1\>"\[IndentingNewLine], 
              IndexTag \[Rule] "\<1.1\>"\[IndentingNewLine]]\
\[IndentingNewLine]\[IndentingNewLine], 
            Item[\[IndentingNewLine]"\<reminders / \
tips\>"\[IndentingNewLine], "\<jutils.help.nb\>"\[IndentingNewLine], 
              CopyTag \[Rule] "\<S1.6.1\>"\[IndentingNewLine], 
              IndexTag \[Rule] "\<1.1\>"\[IndentingNewLine]]\
\[IndentingNewLine]\[IndentingNewLine], 
            Item[\[IndentingNewLine]"\<fNBookForm\>"\[IndentingNewLine], \
"\<jutils.help.nb\>"\[IndentingNewLine], 
              CopyTag \[Rule] "\<S1.7.1\>"\[IndentingNewLine], 
              IndexTag \[Rule] "\<1.1\>"\[IndentingNewLine]]\
\[IndentingNewLine]\[IndentingNewLine], 
            Item[\[IndentingNewLine]"\<Periodic Table of Elements\>"\
\[IndentingNewLine], "\<jutils.help.nb\>"\[IndentingNewLine], 
              CopyTag \[Rule] "\<S1.8.1\>"\[IndentingNewLine], 
              IndexTag \[Rule] "\<1.1\>"\[IndentingNewLine]]\
\[IndentingNewLine]\[IndentingNewLine]}];\)\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(browsercategory >> \ "\<~/jutils/BrowserCategories.m\>"\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(browsercategory >> \ \
"\<~/.Mathematica/4.0/AddOns/Applications/jutils/Documentation/English/\
BrowserCategories.m\>"\)], "Input"],

Cell[BoxData[
    \(\(Remove[browsercategory];\)\)], "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["EndPackage", "Subtitle"],

Cell[BoxData[
    \(\(End[];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(On[General::"\<spell\>"];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(EndPackage[];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["etc", "Subtitle"],

Cell[CellGroupData[{

Cell["context resolving worksheet -- which x ??", "Subsubsection"],

Cell[TextData[{
  StyleBox["\tresult :  there's no way to use \"x\" as shorthand\n\t\t",
    FontWeight->"Bold"],
  "without clobbering and weird goings on"
}], "Text"],

Cell["\<\
\tTo use \"x\" it can NOT already be under any $ContextPath
\t\t(unless you intend environment change of some Package)
\tm`x  is always OK , and m`n`x is safe
\t\tm`x is x of all first nodes of $ContextPath UNTIL
\t\tother`x   is set anywhere - then other`x is x in all nodes
\tif $ContextPath is removed all functions dissapear , not good\
\>", "Text"],

Cell["\<\
*  in general : only use \"x\" if it's \"being watched\" \
appropriately, see \"why not to try\" below\
\>", "Text"],

Cell[BoxData[
    \($Packages\)], "Input"],

Cell[BoxData[
    \(Context[$ContextPath]\)], "Input"],

Cell["\<\
BeginPackage sets things up so that only System` and the named \
context are in the context search path. EndPackage undoes this and adds name \
to path.
\t{name`,{name`,System`}}
\t`jutils`x in Context[x] - if not shadowed
\tbut BoxForm`x is not\
\>"],

Cell["\<\
$Context - context variables are looked for in LAST or created in
$ContextPath - contexts to search symbols
\t* but NOT Context names
\t* non-recursive , sub-contexts are not found
Begin / End are simply push / pop\
\>", "Text"],

Cell["\<\
Context names are Temporary (dissapear) but $ContextPath does NOT \
follow that.  Additionally,  Global` can be remoeved / dissapes, but \
reappears / is default.
Context variables are temporary / are garbage collected
\tHOWEVER - if shadowed the next variable 
\tof same name in $ContextPath will be present\
\>", "Text"],

Cell["\<\
** important to keep in mind that entering $Context doesn't change \
$ContextPath , which means once \"x\" is defined in CP it shadows all \
$Context that do not push / pop $ContextPath
* keep in mind context names ARE NOT replaced ever : 
\tn` is always a base node
\t`n`x in n` -> Global`n`n`x
\t`n` in Global -> Global`n`x
context adds $NewSymbol as appropriate , per say\
\>", "Text"],

Cell[TextData[{
  "*  why not to try : if careful and vars are created with NO $ContextPath \
then context is set first in path (which ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " does not do) then , only if nothing sets any of these , shorthand can be \
used.  But if $ContextPath is not restored due to error that might be or \
become bad.\n\tSystem`$ContextPath={\"Global`\",\"System`\"}\nNote that \
doesn't restore what had been , and wouldn't unless pushed and popped in \
System , and who knows what happens before it's found out or if [session] \
could be lost or very difficult."
}], "Text"],

Cell[BoxData[
    \(\(orig = Contexts[];\)\)], "Input"],

Cell[BoxData[
    \(Remove[x, m`x, n`x, `n`x]\)], "Input"],

Cell[BoxData[
    \(Begin["\<m`\>"]\)], "Input"],

Cell[BoxData[
    \({$Context, $ContextPath}\)], "Input"],

Cell["DO NOT USE: is Global`x or m`x", "Text"],

Cell[BoxData[
    \(x = 1\)], "Input"],

Cell[BoxData[
    \(Context[x]\)], "Input"],

Cell[BoxData[
    \(End[]\)], "Input"],

Cell[BoxData[
    \({$Context, $ContextPath}\)], "Input"],

Cell[BoxData[
    \(x = 2\)], "Input"],

Cell[BoxData[
    \({m`x, x}\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell["\<\
  -----------------------------------------------------------\
\>", \
"Text"],

Cell[BoxData[
    \(Remove[x]\)], "Input"],

Cell[BoxData[
    \(Begin["\<`n`\>"]\)], "Input"],

Cell[BoxData[
    \({$Context, $ContextPath}\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell["DO NOT USE: is Global`x or Global`n`x", "Text"],

Cell[BoxData[
    \(x = 3\)], "Input"],

Cell[BoxData[
    \(Context[x]\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell[BoxData[
    \(n`x = 4\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell[BoxData[
    \(`n`x = 5\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell[BoxData[
    \(Global`n`x = 6\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell[BoxData[
    \(Context[x]\)], "Input"],

Cell[BoxData[
    \(End[]\)], "Input"],

Cell[BoxData[
    \({$Context, $ContextPath}\)], "Input"],

Cell[BoxData[
    \({m`x, x, Global`x, Global`n`x, `n`x, n`x, Global`n`n`x}\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell[BoxData[
    \(Remove[x, m`x, n`x, `n`x, `n`n`x]\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell["\<\
  -----------------------------------------------------------\
\>", \
"Text"],

Cell["      part 2 , x is left in Global` before defnitinos", "Text"],

Cell["\<\
  -----------------------------------------------------------\
\>", \
"Text"],

Cell[BoxData[
    \(Remove[x, m`x, n`x, `n`x, `n`x]\)], "Input"],

Cell[BoxData[
    \(x = 2\)], "Input"],

Cell[BoxData[
    \(Begin["\<m`\>"]\)], "Input"],

Cell[BoxData[
    \({$Context, $ContextPath}\)], "Input"],

Cell["DO NOT USE: is Global`x or m`x", "Text"],

Cell[BoxData[
    \(x = 1\)], "Input"],

Cell[BoxData[
    \(Context[x]\)], "Input"],

Cell[BoxData[
    \(End[]\)], "Input"],

Cell[BoxData[
    \({$Context, $ContextPath}\)], "Input"],

Cell[BoxData[
    \(x = 2\)], "Input"],

Cell[BoxData[
    \({m`x, x}\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell["\<\
  -----------------------------------------------------------\
\>", \
"Text"],

Cell[BoxData[
    \(Begin["\<`n`\>"]\)], "Input"],

Cell[BoxData[
    \({$Context, $ContextPath}\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell["DO NOT USE: is Global`x or Global`n`x", "Text"],

Cell[BoxData[
    \(x = 3\)], "Input"],

Cell[BoxData[
    \(Context[x]\)], "Input"],

Cell[BoxData[
    \($Context\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell[BoxData[
    \(n`x = 4\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell[BoxData[
    \(`n`x = 5\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell[BoxData[
    \(Global`n`x = 6\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell[BoxData[
    \(Context[x]\)], "Input"],

Cell[BoxData[
    \(End[]\)], "Input"],

Cell[BoxData[
    \({$Context, $ContextPath}\)], "Input"],

Cell[BoxData[
    \({m`x, x, Global`x, Global`n`x, `n`x, n`x, Global`n`n`x}\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell["======================", "Text"],

Cell["note  n`  is a level with Global` despite stated within `n`", "Text"],

Cell["======================", "Text"],

Cell[BoxData[
    \( (*\ Remove[x, m`x, n`x, `n`x, `n`n`x]\ *) \)], "Input"],

Cell[BoxData[
    \( (*\ Complement[Contexts[], orig]\ *) \)], "Input"],

Cell[BoxData[
    \(Remove[m`x, `n`x, `n`n`x]\)], "Input"],

Cell[BoxData[
    \({m`x, x, Global`x, Global`n`x, `n`x, n`x, Global`n`n`x}\)], "Input"],

Cell[BoxData[
    \(Remove[m`x, `n`x, `n`n`x]\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell[BoxData[
    \(Remove[x, n`x]\)], "Input"],

Cell[BoxData[
    \({m`x, x, Global`x, Global`n`x, `n`x, n`x, Global`n`n`x}\)], "Input"],

Cell[BoxData[
    \(Remove[x, m`x, n`x, `n`x, `n`n`x]\)], "Input"],

Cell[BoxData[
    \(Complement[Contexts[], orig]\)], "Input"],

Cell[BoxData[
    \({{Names["\<m`*\>"]}, {Names["\<n`*\>"]}, {Names["\<`n`*\>"]}, \
{Names["\<n`n`*\>"]}, {Names["\<`n`n`*\>"]}}\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Development Notes for CreateModule", "Subsubsection"],

Cell["\<\
this line had stripped context names only from variables.  this \
probably doesn't help anything.\
\>", "Text"],

Cell[BoxData[
    \(\(vars2 = 
        Map[\((StringReplace[#, context2 \[Rule] "\<\>"] &)\), 
          Names[con2]];\)\)], "Input",
  Evaluatable->False],

Cell["\<\
this would be perfect to remove c`p` but Names already excludes it \
for us\
\>", "Text"],

Cell[BoxData[
    \(Select[{"\<c1`p`x\>", "\<c1`x\>"}, \((\[Not] StringMatchQ[#, \
"\<c1`p`*\>"] &)\)]\)], "Input",
  Evaluatable->False],

Cell[TextData[ButtonBox["2.10.3",
  ButtonData:>{"2.10.3", "3.21"},
  ButtonStyle->"MainBookLink"]], "Text"],

Cell[TextData[{
  "The 2D array dimensions for array Module are very picky for \"module\" \
(evaluate parser must group by / collect between [] , thus nested boxing, but \
boxes inside must not be unecessarily nested : see CombineCells dev. notes )\n\
\n\tEvaluate ",
  StyleBox["will freeze",
    FontWeight->"Bold"],
  " if it is not jsut so :"
}], "Text"],

Cell["\<\
C [ B [ R1 [{ Rh [{ hd , Rm [ { mod , Ra [ {  Rb [ { VARS , BODY \
}]b  }]a  
, \"\\n\" , endmod  }]m  }]h  , \";\" }]1  ]b , \"Input\" ]c\
\>", "Text"],

Cell["\<\
at first think \"drop the hd := Mod\" and return Definition.  but \
that will not help (see notes for CombineCells)\
\>", "Text"],

Cell["\<\
C [ B [ R1 [{ 
\tRh [{ \thd , \":=\", 
\t\tRm [ { mod , 
\t\t\tRa [ {  Rb [ { VARS , BODY }]b  }]a  
\t\t\t, \"IndentingNewLine\" , endmod  
\t\t}]m  
\t}]h  , \";\"
}]1  ]B , \"Input\" ]\
\>", "Text"],

Cell["\<\
Somehow CreateModules gets an IndentingNewLine after Body that \
doesn't come from CombineCells.  (likely from Rowbox[x] ).  So where it is \
above it's omitted and looks the same.  Should be ok fine.\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["Development Notes for CombineCell", "Subsubsection",
  Editable->False],

Cell["\<\
First note that Boxes etc are in a Notebook deal with Standard Form \
boxes which represent expressions but also decorations (ie, comments) or \
text.  (ie, RowBox) and not FullForm.\
\>", "Text",
  Editable->False],

Cell["\<\
Anything using the result of combining cells doesn't need \"extra \
problems\" to do.  The below notes 2 things Combine Cells does to provide a \
cleaner result.\
\>", "Text",
  Editable->False],

Cell["---------------------------------------", "Text",
  Editable->False],

Cell["\<\
Step 1.  First note NotebookRead will get : 
\t\"Cell [ BoxData [ RowBox [{ RowBox [{ RowBox [{ data .}] , extra }]  }] \
]\"
CombineCells wants :
\t\"{ RowBox [{ data }]  , extra }\"
\t
note that's \"

assuming one RowBox is needed to wrap expr (a single expr / line in a \
module).  That part is solved by simple indexing and the \
\"Length[Position[data2,RowBox]]>1\" check.  Because a final wrapper is \
places for all lines combined the extras are not left unboxed.

See below for more about extra wrapping and problems that occur with it.  \
(improper evaluation and or Kernel freeze / disconnect to Front End )\
\>", \
"Text",
  Editable->False],

Cell["---------------------------------------", "Text",
  Editable->False],

Cell["Step 2.  HOWEVER.", "Text",
  Editable->False],

Cell["\<\
To work with more trivial examples of combining lines NotebookRead \
leaves another problem ... (and I hope not worse or more !)\
\>", "Text",
  Editable->False],

Cell["\<\
The Front End does \"nesting of compound expressions\" (nesting of \
RowBoxes) and it can display that in 2D (but this isn't evalutation).  For a \
single cell and expr this works and is stored in the Notebook that way.  But \
for a cell with compound expressions in a cell the Front End actually undoes \
the nesting as you edit BEFORE it's stored and or evaluated , and then stores \
it not nested.  Hmm.\
\>", "Text",
  Editable->False],

Cell[TextData[{
  "Unfortunately if one wishes to Combine lines one is left with undoing the \
nesting \"shoft hand\" the Front End has left and there is no ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " documented way I know that undoes this.  Note \"FromBoxes\" combined with \
\"ToExpression\" will not work since ToExpression requires evaluation which , \
due to shorthand and that FromBoxes is not made to undo it: can't and doesn't \
work as is.  And if made to (after step 1above) and were protected from \
evaluating : all decorators are removed so the result is then unusable \
further except as .mx source."
}], "Text",
  Editable->False],

Cell["ANSWER:", "Text",
  Editable->False],

Cell["\<\
Modules are made of a line (or lines using \"\\n\") of compound \
expressions , these are completely determined by placement of the Compound \
Expression operator \";\"

Compound expressions within Module must not use a RowBox wrapper to wrap the \
compound expression operator \";\"  
\tBAD: { RowBox[{ RowBox[{ \"y\" }] , \";\" }] }
\t\tNOTE \";\" is within an outermost box but outside box it applies to.
\t\tThis is ok for one cell but when combining cells it can't be used.
\t\tIt isn't as simple as removing it , see why below.
\tGOOD : { RowBox[{ \"x\" }] , \";\" }
\t\tthis can be combined and an outer RowBox added to all
\tand NOTE the {} the parens (added) are needed when matching\
\>", "Text",
  Editable->False],

Cell["\<\
Problem is, for CombineCells , that for a single Cell the Front End \
can and will \"wrap\" (bad) expr and comound separator whenever there is \
anything intervening the expr and compound expr operator.  That's frequently: \
it includes white space, comments , anything.
\tnot wrapped: \"expr1;expr2;expr3;\"
\tget wrapped: \"expr1 ; expr2 ; expr3 ;\"\
\>", "Text",
  Editable->False],

Cell["\<\
This hopefully does more good than bad  ...
\ta,  anything preceeding compound expr
\tb,  the expr
\th, anything preceeding compound expr separator \";\"
\td, anything after compound expr separator \";\"\
\>", "Text",
  Editable->False],

Cell["\<\
\tdata /.
\t{a:___,RowBox[{RowBox[{b:___}],h:___,y:\";\",d:___}],c:___}\[Rule]
\t{a,RowBox[{b}],y,h,d,c}\
\>", "Text",
  Editable->False],

Cell["\<\
The rule above rewrites \"bad to good\".  Hopefully it does no harm \
to structures which might un-intentionally match.  (if so, add ex, \
b:___/;b!=what)\
\>", "Text",
  Editable->False],

Cell["\<\
If one combines cells manually (using Show Expression) and edites \
it with the Front End one sees the front end keeps bad but when any editing \
occurs rewrites it : even if the editing result changes nothing (add return \
then remove it) it is restructured to undo the nesting.

Infact it isn't as if the Front End never has problems.  When working with \
edited modules the Front End sometime create an error box that replaces one's \
ORIGIONAL SOURCE with red underlined junk ... which in effect deletes one's \
un-saved work !\
\>", "Text",
  Editable->False],

Cell[TextData[{
  "Finally.  What is more suble.  The Kernel does use nesting of expression \
for If , Table, Function[x_]:=y, Module, etc, which are ",
  StyleBox["exceptions",
    FontSlant->"Italic"],
  " looked for, and if they are wrapped in boxes when handed to ToExpression \
",
  StyleBox["the nesting of boxes shouldn't be confused with the nesting of \
expressions",
    FontWeight->"Bold"],
  ".  (",
  StyleBox["exceptions",
    FontSlant->"Italic"],
  " are grouping [] , lists read and interpreted with special meaning, etc",
  ")\n\nFinally, to add possible confusion, ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " input forms do not generically see nesting as boxing :\n\tToExpression[\"\
\\(x\\^y\\^x\\^z\\)\"] \tnest boxes x^y^z\n\tToExpression[\"\\(x\\^y \
\\(x^z\\) \\)\"] \tunboxes x^z\n\tToExpression[\"\\(x\\^y\\^\\(x^z\\) \\)\"] \
\tis x^y^(x^z unboxed)\nthe nested textform box expression un-boxes x^z (it \
does not nest-box it as one might think)."
}], "Text",
  Editable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToExpression["\<\(x\^y\^x\^z\)\>"]\)], "Input",
  Editable->False,
  Evaluatable->False],

Cell[BoxData[
    \(SuperscriptBox["x", 
      SuperscriptBox["y", SuperscriptBox["x", "z"]]]\)], "Output",
  Editable->False]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToBoxes[
      Unevaluated[\[IndentingNewLine]\(Module[{x}, 
            Print["\<bob\>"]\ ; \  (*x*) 
              Print["\<bib\>"];];\)\[IndentingNewLine]]]\)], "Input",
  Editable->False,
  Evaluatable->False],

Cell[BoxData[
    \(RowBox[{RowBox[{"Module", "[", 
            RowBox[{RowBox[{"{", "x", "}"}], ",", 
                RowBox[{RowBox[{"Print", "[", "\"bob\"", "]"}], ";", 
                    RowBox[{"Print", "[", "\"bib\"", "]"}], ";"}]}], "]"}], 
        ";"}]\)], "Output",
  Editable->False]
}, Closed]],

Cell[BoxData[
    \(RowBox[{RowBox[{"\<Module\>", "\<[\>", \[IndentingNewLine]RowBox[{\
\[IndentingNewLine]\t
                RowBox[{"\<{\>", "\<x\>", "\<}\>"}], "\<,\>", \
\[IndentingNewLine]\t
                RowBox[{\[IndentingNewLine]\t
                    RowBox[{"\<Print\>", "\<[\>", "\<\"bob\"\>", "\<]\>"}], "\
\<;\>", \[IndentingNewLine]\t
                    RowBox[{"\<Print\>", "\<[\>", "\<\"bib\"\>", "\<]\>"}], "\
\<;\>"\[IndentingNewLine]\t}]\[IndentingNewLine]}]\[IndentingNewLine], \
"\<]\>"}], "\<;\>"}]\)], "Input",
  Editable->False,
  Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToExpression[%]\)], "Input",
  Editable->False,
  Evaluatable->False],

Cell[BoxData[
    \("bob"\)], "Print",
  Editable->False],

Cell[BoxData[
    \("bib"\)], "Print",
  Editable->False]
}, Closed]],

Cell["\<\
wtth respece ot outer box the \";\" are outside expr they separate. \
 however if (*x*) had not been deleted the \"simple way\" will not \
work.\
\>", "Text",
  Editable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(RowBox[{RowBox[{"\<Module\>", "\<[\>", \[IndentingNewLine]RowBox[{\
\[IndentingNewLine]\t
                RowBox[{"\<{\>", "\<x\>", "\<}\>"}], "\<,\>", \
\[IndentingNewLine]\t
                RowBox[{\[IndentingNewLine]\t
                    RowBox[{\t\[IndentingNewLine]\t
                          RowBox[{"\<Print\>", "\<[\>", "\<\"bob\"\>", \
"\<]\>"}], "\<;\>", \ "\< \>"}]\[IndentingNewLine]\t
                      RowBox[{"\<Print\>", "\<[\>", "\<\"bib\"\>", "\<]\>"}], \
"\<;\>"\[IndentingNewLine]\t}]\[IndentingNewLine]}]\[IndentingNewLine], \
"\<]\>"}], "\<;\>"}]\)], "Input",
  Editable->False,
  Evaluatable->False],

Cell[BoxData[
    \(RowBox[{RowBox[{"Module", "[", 
            RowBox[{RowBox[{"{", "x", "}"}], ",", 
                RowBox[{RowBox[{RowBox[{"Print", "[", "\"bob\"", "]"}], ";", 
                          " "}]\ RowBox[{"Print", "[", "\"bib\"", "]"}], 
                    ";"}]}], "]"}], ";"}]\)], "Output",
  Editable->False]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToExpression[%]\)], "Input",
  Editable->False,
  Evaluatable->False],

Cell[BoxData[
    \(Syntax::"sntxb" \(\(:\)\(\ \)\) 
      "Expression cannot begin with \"\!\(\(\(\(\((\(\(Print[\"bob\"]\)\) ;\\ \
)\)\)\\ \(\(Print[\"bib\"]\)\)\)\) ;\)\".\!\(\"\"\)"\)], "Message",
  Editable->False],

Cell[BoxData[
    \(ToExpression::"esntx" \(\(:\)\(\ \)\) 
      "Could not parse \!\(RowBox[\(\({\(\(RowBox[\(\({\"Module\", \"[\", \
\(\(RowBox[\(\({\(\[LeftSkeleton] 1 \[RightSkeleton]\)}\)\)]\)\), \"]\"}\)\)]\
\)\), \";\"}\)\)]\) as Mathematica input."\)], "Message",
  Editable->False],

Cell[BoxData[
    \($Failed\)], "Output",
  Editable->False]
}, Closed]],

Cell["\<\
The above is fails due the a single white space not due to the \
whitespace but due to the way it would be wrapped when read by \
NotebookRead.\
\>", "Text",
  Editable->False],

Cell[BoxData[
    \(\(boxes = 
        ToBoxes[Unevaluated[\[IndentingNewLine]\[IndentingNewLine]RowBox[{\
Module, "\<[\>", \[IndentingNewLine]RowBox[{"\<{\>", "\<x\>", "\<}\>"}], "\<,\
\>", \[IndentingNewLine]RowBox[{\[IndentingNewLine]RowBox[{RowBox[{Print, \
"\<[\>", "\<bob\>", "\<]\>"}], "\<;\>"}], "\<\n\>", "\< \
\>"\[IndentingNewLine], \[IndentingNewLine]RowBox[{RowBox[{Print, "\<[\>", \
"\<bob\>", "\<]\>"}], "\<;\>"}], "\< \>"\[IndentingNewLine]}]\
\[IndentingNewLine], "\<]\>"}]\[IndentingNewLine]\[IndentingNewLine]]];\)\)], \
"Input",
  Editable->False,
  Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(cell = Cell[BoxData[ToExpression[boxes]], "\<Input\>"];\)\)], "Input",\

  Editable->False,
  Evaluatable->False],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(cell\)\" is similar to \
existing symbol \"\!\(Cell\)\"."\)], "Message",
  Editable->False]
}, Closed]],

Cell[BoxData[
    \(\(CellPrint[cell];\)\)], "Input",
  Editable->False,
  Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(Module[{x}, \(Print[bob];\)\n\ \(Print[bob];\)\ ]\)], "Input",
  Editable->False,
  Evaluatable->False,
  GeneratedCell->True,
  CellAutoOverwrite->True],

Cell[BoxData[
    \(bob\)], "Print",
  Editable->False],

Cell[BoxData[
    \(bob\)], "Print",
  Editable->False],

Cell[BoxData[
    \(Null\^2\)], "Output",
  Editable->False]
}, Closed]],

Cell["\<\
The above fails to evaluate correctly becuase ToBoxes does not \
\"undo\" the nesting of \";\".\
\>", "Text",
  Editable->False],

Cell[BoxData[
    \(Remove[boxes, cell, x, y]\)], "Input",
  Editable->False,
  Evaluatable->False],

Cell[TextData[{
  "P.S.  for interest , another ",
  StyleBox["exception",
    FontSlant->"Italic"],
  " to expr 2D appearance v. evaluation is how boxes and operators map to \
Function , and here is one way 2D and evaluation are revealed :"
}], "Text",
  Editable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(InterpretationBox[SuperscriptBox["\<x\>", "\<2\>"], Plus[x, 2]] // 
      DisplayForm\)], "Input",
  Editable->False,
  Evaluatable->False],

Cell[BoxData[
    TagBox[
      InterpretationBox[\(x\^2\),
        Plus[ x, 2]],
      DisplayForm]], "Output",
  Editable->False]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToExpression[%]\)], "Input",
  Editable->False,
  Evaluatable->False],

Cell[BoxData[
    \(2 + x\)], "Output",
  Editable->False]
}, Closed]],

Cell[TextData[{
  "see ",
  ButtonBox["Section 2.8.17",
    ButtonData:>{"2.8.17", "17.2"},
    ButtonStyle->"MainBookLink"],
  " about MakeExpression, MakeBoxes , ToBoxes, ToExpression, Format, \
StringForm, SequenceForm, Infix and precedencee, ..."
}], "Text",
  Editable->False],

Cell[TextData[{
  "This is interesting and can be inserted before Rule in the While loop.  \
However cannot be directly used.  It's also \"low level\" and may require low \
level details on a per case basis (ie, for If[] ).\n\n\
data3=ToString[MakeExpression[RowBox[data2],StandardForm]];\n\
Print[ToString[data3]];\ndata3=ToString[MakeBoxes[data3,StandardForm]];\n\
Print[ToString[data3]];\n\nOOPS ... going from MakeBoxes to MakeExpression is \
easy.  However going the other way around is completely wacked out.  \
MakeExpression from Notebook is a Sequence held by HoldComplete containing \
fluff , Nulls, and expressions intermixed - needing to be \"undone\".\n\n\
Often the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " book shows the slide toward the bottom of the hill in it's Examples."
}], "Text",
  Editable->False]
}, Closed]]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1280}, {0, 1024}},
AutoGeneratedPackage->None,
ShowPageBreaks->False,
WindowSize->{594, 535},
WindowMargins->{{64, Automatic}, {-27, Automatic}},
IndexCreationOptions->{"Format"->"Text"},
ShowCellTags->True,
Magnification->1
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 37, 0, 42, "Subsubsection"],
Cell[1779, 53, 30, 0, 31, "Text"],
Cell[1812, 55, 33, 0, 31, "Text"],
Cell[1848, 57, 54, 0, 31, "Text"],
Cell[1905, 59, 202, 8, 133, "Text"],
Cell[2110, 69, 44, 0, 31, "Text"],
Cell[2157, 71, 40, 0, 31, "Text"],
Cell[2200, 73, 39, 0, 31, "Text"],
Cell[2242, 75, 25, 0, 31, "Text"],
Cell[2270, 77, 26, 0, 31, "Text"],
Cell[2299, 79, 98, 3, 31, "Text"],
Cell[2400, 84, 41, 0, 31, "Text"],
Cell[2444, 86, 302, 9, 150, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[2783, 100, 48, 0, 28, "Subsubsection"],
Cell[2834, 102, 73, 0, 31, "Text"],
Cell[2910, 104, 26, 0, 31, "Text"],
Cell[2939, 106, 333, 8, 83, "Text"],
Cell[3275, 116, 167, 4, 65, "Text"],
Cell[3445, 122, 335, 8, 133, "Text"],
Cell[3783, 132, 123, 4, 65, "Text"],
Cell[3909, 138, 98, 3, 31, "Text"],
Cell[4010, 143, 217, 6, 99, "Text"],
Cell[4230, 151, 123, 3, 48, "Text"],
Cell[4356, 156, 90, 3, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[4483, 164, 39, 0, 28, "Subsubsection"],
Cell[4525, 166, 177, 4, 48, "Text"],
Cell[4705, 172, 416, 8, 133, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[5158, 185, 31, 0, 82, "Title"],

Cell[CellGroupData[{
Cell[5214, 189, 27, 0, 45, "Subsection"],
Cell[5244, 191, 27, 0, 31, "Text"],
Cell[5274, 193, 63, 1, 31, "Text",
  InitializationCell->True],
Cell[5340, 196, 79, 1, 31, "Text",
  InitializationCell->True],
Cell[5422, 199, 99, 3, 31, "Text"],
Cell[5524, 204, 829, 25, 66, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[6390, 234, 32, 0, 53, "Subtitle"],
Cell[6425, 236, 93, 2, 27, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[6543, 242, 29, 0, 45, "Subsection"],
Cell[6575, 244, 91, 2, 27, "Input",
  InitializationCell->True],
Cell[6669, 248, 104, 2, 27, "Input",
  InitializationCell->True],
Cell[6776, 252, 90, 2, 27, "Input",
  InitializationCell->True],
Cell[6869, 256, 91, 2, 27, "Input",
  InitializationCell->True],
Cell[6963, 260, 187, 3, 59, "Input",
  InitializationCell->True],
Cell[7153, 265, 208, 4, 59, "Input",
  InitializationCell->True],
Cell[7364, 271, 208, 4, 59, "Input",
  InitializationCell->True],
Cell[7575, 277, 177, 3, 59, "Input",
  InitializationCell->True],
Cell[7755, 282, 152, 3, 43, "Input",
  InitializationCell->True],
Cell[7910, 287, 152, 3, 43, "Input",
  InitializationCell->True],
Cell[8065, 292, 219, 4, 75, "Input",
  InitializationCell->True],
Cell[8287, 298, 132, 3, 27, "Input",
  InitializationCell->True],
Cell[8422, 303, 133, 3, 27, "Input",
  InitializationCell->True],
Cell[8558, 308, 133, 3, 27, "Input",
  InitializationCell->True],
Cell[8694, 313, 122, 3, 27, "Input",
  InitializationCell->True],
Cell[8819, 318, 141, 3, 43, "Input",
  InitializationCell->True],
Cell[8963, 323, 125, 3, 27, "Input",
  InitializationCell->True],
Cell[9091, 328, 71, 2, 27, "Input",
  InitializationCell->True],
Cell[9165, 332, 128, 3, 27, "Input",
  InitializationCell->True],
Cell[9296, 337, 128, 3, 27, "Input",
  InitializationCell->True],
Cell[9427, 342, 124, 3, 27, "Input",
  InitializationCell->True],
Cell[9554, 347, 119, 2, 27, "Input",
  InitializationCell->True],
Cell[9676, 351, 131, 3, 27, "Input",
  InitializationCell->True],
Cell[9810, 356, 122, 3, 27, "Input",
  InitializationCell->True],
Cell[9935, 361, 112, 2, 27, "Input",
  InitializationCell->True],
Cell[10050, 365, 110, 2, 27, "Input",
  InitializationCell->True],
Cell[10163, 369, 29, 0, 31, "Text"],
Cell[10195, 371, 156, 3, 59, "Input",
  Evaluatable->False],
Cell[10354, 376, 155, 3, 59, "Input",
  Evaluatable->False],
Cell[10512, 381, 195, 4, 59, "Input",
  Evaluatable->False],
Cell[10710, 387, 195, 4, 59, "Input",
  Evaluatable->False],
Cell[10908, 393, 101, 2, 27, "Input",
  InitializationCell->True],
Cell[11012, 397, 100, 2, 27, "Input",
  InitializationCell->True],
Cell[11115, 401, 99, 2, 27, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[11239, 407, 43, 0, 42, "Subsubsection"],
Cell[11285, 409, 51, 0, 31, "Text"],
Cell[11339, 411, 84, 2, 27, "Input",
  InitializationCell->True],
Cell[11426, 415, 122, 3, 27, "Input",
  InitializationCell->True],
Cell[11551, 420, 158, 4, 43, "Input",
  InitializationCell->True],
Cell[11712, 426, 156, 4, 43, "Input",
  InitializationCell->True],
Cell[11871, 432, 71, 2, 27, "Input",
  InitializationCell->True],
Cell[11945, 436, 34, 0, 31, "Text"],
Cell[11982, 438, 114, 2, 27, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[12145, 446, 26, 0, 29, "Subsection"],
Cell[12174, 448, 157, 4, 48, "Text"],
Cell[12334, 454, 179, 4, 65, "Text"],

Cell[CellGroupData[{
Cell[12538, 462, 35, 0, 42, "Subsubsection"],
Cell[12576, 464, 90, 2, 27, "Input",
  InitializationCell->True],
Cell[12669, 468, 92, 2, 27, "Input",
  InitializationCell->True],
Cell[12764, 472, 82, 2, 27, "Input",
  InitializationCell->True],
Cell[12849, 476, 84, 2, 27, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[12970, 483, 38, 0, 28, "Subsubsection"],
Cell[13011, 485, 196, 4, 65, "Text"],
Cell[13210, 491, 187, 3, 59, "Input",
  InitializationCell->True],
Cell[13400, 496, 754, 14, 251, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[14191, 515, 37, 0, 28, "Subsubsection"],
Cell[14231, 517, 116, 3, 48, "Text"],
Cell[14350, 522, 384, 8, 167, "Text"],
Cell[14737, 532, 189, 3, 43, "Input",
  InitializationCell->True],
Cell[14929, 537, 53, 0, 31, "Text"],
Cell[14985, 539, 3272, 58, 683, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[18294, 602, 37, 0, 28, "Subsubsection"],
Cell[18334, 604, 272, 5, 59, "Input",
  InitializationCell->True],
Cell[18609, 611, 54, 0, 31, "Text"],
Cell[18666, 613, 4674, 76, 1099, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[23377, 694, 30, 0, 28, "Subsubsection"],
Cell[23410, 696, 105, 3, 48, "Text"],
Cell[23518, 701, 275, 5, 43, "Input",
  InitializationCell->True],
Cell[23796, 708, 5498, 103, 1387, "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[29343, 817, 30, 0, 53, "Subsubtitle"],
Cell[29376, 819, 88, 2, 27, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[29489, 825, 26, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[29540, 829, 30, 0, 42, "Subsubsection"],
Cell[29573, 831, 148, 4, 43, "Input",
  InitializationCell->True],
Cell[29724, 837, 146, 3, 43, "Input",
  InitializationCell->True],
Cell[29873, 842, 715, 13, 235, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[30625, 860, 31, 0, 28, "Subsubsection"],
Cell[30659, 862, 53, 0, 31, "Text"],
Cell[30715, 864, 160, 4, 43, "Input",
  InitializationCell->True],
Cell[30878, 870, 53, 0, 31, "Text"],
Cell[30934, 872, 157, 3, 43, "Input",
  InitializationCell->True],
Cell[31094, 877, 52, 0, 31, "Text"],
Cell[31149, 879, 103, 2, 27, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[31289, 886, 29, 0, 28, "Subsubsection"],
Cell[31321, 888, 104, 2, 27, "Input",
  InitializationCell->True],
Cell[31428, 892, 46, 0, 31, "Text"],
Cell[31477, 894, 94, 2, 27, "Input",
  InitializationCell->True],
Cell[31574, 898, 47, 0, 31, "Text"],
Cell[31624, 900, 113, 2, 27, "Input",
  Evaluatable->False],
Cell[31740, 904, 82, 2, 27, "Input",
  Evaluatable->False],
Cell[31825, 908, 55, 0, 31, "Text"],
Cell[31883, 910, 157, 3, 43, "Input",
  InitializationCell->True],
Cell[32043, 915, 137, 3, 27, "Input",
  InitializationCell->True],
Cell[32183, 920, 93, 2, 27, "Input",
  Evaluatable->False],
Cell[32279, 924, 40, 0, 31, "Text"],
Cell[32322, 926, 76, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[32435, 932, 27, 0, 28, "Subsubsection"],
Cell[32465, 934, 1100, 18, 251, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[33602, 957, 27, 0, 28, "Subsubsection"],
Cell[33632, 959, 1827, 31, 395, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[35496, 995, 28, 0, 28, "Subsubsection"],
Cell[35527, 997, 69, 0, 31, "Text"],
Cell[35599, 999, 131, 3, 27, "Input",
  InitializationCell->True],
Cell[35733, 1004, 122, 3, 27, "Input",
  InitializationCell->True],
Cell[35858, 1009, 112, 2, 27, "Input",
  InitializationCell->True],
Cell[35973, 1013, 110, 2, 27, "Input",
  InitializationCell->True],
Cell[36086, 1017, 149, 3, 48, "Text"],
Cell[36238, 1022, 365, 6, 99, "Text"],
Cell[36606, 1030, 108, 3, 48, "Text"],
Cell[36717, 1035, 327, 7, 75, "Input",
  InitializationCell->True],
Cell[37047, 1044, 139, 3, 48, "Text"],
Cell[37189, 1049, 143, 3, 48, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[37369, 1057, 28, 0, 28, "Subsubsection"],
Cell[37400, 1059, 247, 6, 66, "Text"],
Cell[37650, 1067, 448, 8, 107, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[38135, 1080, 28, 0, 28, "Subsubsection"],
Cell[38166, 1082, 408, 7, 123, "Input",
  InitializationCell->True],
Cell[38577, 1091, 268, 9, 150, "Text"],
Cell[38848, 1102, 37, 0, 31, "Text"],
Cell[38888, 1104, 25, 0, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[38950, 1109, 28, 0, 28, "Subsubsection"],
Cell[38981, 1111, 233, 4, 59, "Input",
  InitializationCell->True],
Cell[39217, 1117, 91, 4, 65, "Text"],
Cell[39311, 1123, 191, 5, 82, "Text"],
Cell[39505, 1130, 110, 3, 48, "Text"],
Cell[39618, 1135, 280, 5, 82, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[39935, 1145, 34, 0, 28, "Subsubsection"],
Cell[39972, 1147, 48, 0, 31, "Text"],
Cell[40023, 1149, 212, 5, 43, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[40272, 1159, 35, 0, 28, "Subsubsection"],
Cell[40310, 1161, 99, 3, 31, "Text"],
Cell[40412, 1166, 227, 5, 75, "Input",
  Evaluatable->False],
Cell[40642, 1173, 235, 5, 75, "Input",
  Evaluatable->False],
Cell[40880, 1180, 234, 5, 75, "Input",
  Evaluatable->False],
Cell[41117, 1187, 234, 5, 75, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[41388, 1197, 28, 0, 28, "Subsubsection"],
Cell[41419, 1199, 110, 2, 27, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[41566, 1206, 29, 0, 28, "Subsubsection"],
Cell[41598, 1208, 137, 3, 27, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[41772, 1216, 30, 0, 28, "Subsubsection"],
Cell[41805, 1218, 165, 4, 43, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[42007, 1227, 40, 0, 28, "Subsubsection"],
Cell[42050, 1229, 34, 0, 31, "Text"],
Cell[42087, 1231, 149, 3, 48, "Text"],
Cell[42239, 1236, 144, 4, 65, "Text"],
Cell[42386, 1242, 3233, 59, 1259, "Input",
  InitializationCell->True],
Cell[45622, 1303, 116, 2, 27, "Input",
  InitializationCell->True],
Cell[45741, 1307, 151, 3, 59, "Input"],
Cell[45895, 1312, 89, 2, 27, "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[46057, 1322, 30, 0, 64, "Subtitle"],
Cell[46090, 1324, 71, 2, 27, "Input",
  InitializationCell->True],
Cell[46164, 1328, 90, 2, 27, "Input",
  InitializationCell->True],
Cell[46257, 1332, 78, 2, 27, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[46372, 1339, 23, 0, 53, "Subtitle"],

Cell[CellGroupData[{
Cell[46420, 1343, 66, 0, 42, "Subsubsection"],
Cell[46489, 1345, 168, 4, 48, "Text"],
Cell[46660, 1351, 363, 7, 116, "Text"],
Cell[47026, 1360, 126, 3, 48, "Text"],
Cell[47155, 1365, 42, 1, 27, "Input"],
Cell[47200, 1368, 54, 1, 27, "Input"],
Cell[47257, 1371, 261, 7, 83, InheritFromParent],
Cell[47521, 1380, 238, 6, 99, "Text"],
Cell[47762, 1388, 332, 7, 116, "Text"],
Cell[48097, 1397, 398, 9, 150, "Text"],
Cell[48498, 1408, 614, 11, 151, "Text"],
Cell[49115, 1421, 55, 1, 27, "Input"],
Cell[49173, 1424, 58, 1, 27, "Input"],
Cell[49234, 1427, 48, 1, 27, "Input"],
Cell[49285, 1430, 57, 1, 27, "Input"],
Cell[49345, 1433, 46, 0, 31, "Text"],
Cell[49394, 1435, 38, 1, 27, "Input"],
Cell[49435, 1438, 43, 1, 27, "Input"],
Cell[49481, 1441, 38, 1, 27, "Input"],
Cell[49522, 1444, 57, 1, 27, "Input"],
Cell[49582, 1447, 38, 1, 27, "Input"],
Cell[49623, 1450, 41, 1, 27, "Input"],
Cell[49667, 1453, 61, 1, 27, "Input"],
Cell[49731, 1456, 87, 3, 31, "Text"],
Cell[49821, 1461, 42, 1, 27, "Input"],
Cell[49866, 1464, 49, 1, 27, "Input"],
Cell[49918, 1467, 57, 1, 27, "Input"],
Cell[49978, 1470, 61, 1, 27, "Input"],
Cell[50042, 1473, 53, 0, 31, "Text"],
Cell[50098, 1475, 38, 1, 27, "Input"],
Cell[50139, 1478, 43, 1, 27, "Input"],
Cell[50185, 1481, 61, 1, 27, "Input"],
Cell[50249, 1484, 40, 1, 27, "Input"],
Cell[50292, 1487, 61, 1, 27, "Input"],
Cell[50356, 1490, 41, 1, 27, "Input"],
Cell[50400, 1493, 61, 1, 27, "Input"],
Cell[50464, 1496, 47, 1, 27, "Input"],
Cell[50514, 1499, 61, 1, 27, "Input"],
Cell[50578, 1502, 43, 1, 27, "Input"],
Cell[50624, 1505, 38, 1, 27, "Input"],
Cell[50665, 1508, 57, 1, 27, "Input"],
Cell[50725, 1511, 88, 1, 27, "Input"],
Cell[50816, 1514, 61, 1, 27, "Input"],
Cell[50880, 1517, 66, 1, 27, "Input"],
Cell[50949, 1520, 61, 1, 27, "Input"],
Cell[51013, 1523, 87, 3, 31, "Text"],
Cell[51103, 1528, 69, 0, 31, "Text"],
Cell[51175, 1530, 87, 3, 31, "Text"],
Cell[51265, 1535, 64, 1, 27, "Input"],
Cell[51332, 1538, 38, 1, 27, "Input"],
Cell[51373, 1541, 48, 1, 27, "Input"],
Cell[51424, 1544, 57, 1, 27, "Input"],
Cell[51484, 1547, 46, 0, 31, "Text"],
Cell[51533, 1549, 38, 1, 27, "Input"],
Cell[51574, 1552, 43, 1, 27, "Input"],
Cell[51620, 1555, 38, 1, 27, "Input"],
Cell[51661, 1558, 57, 1, 27, "Input"],
Cell[51721, 1561, 38, 1, 27, "Input"],
Cell[51762, 1564, 41, 1, 27, "Input"],
Cell[51806, 1567, 61, 1, 27, "Input"],
Cell[51870, 1570, 87, 3, 31, "Text"],
Cell[51960, 1575, 49, 1, 27, "Input"],
Cell[52012, 1578, 57, 1, 27, "Input"],
Cell[52072, 1581, 61, 1, 27, "Input"],
Cell[52136, 1584, 53, 0, 31, "Text"],
Cell[52192, 1586, 38, 1, 27, "Input"],
Cell[52233, 1589, 43, 1, 27, "Input"],
Cell[52279, 1592, 41, 1, 27, "Input"],
Cell[52323, 1595, 61, 1, 27, "Input"],
Cell[52387, 1598, 40, 1, 27, "Input"],
Cell[52430, 1601, 61, 1, 27, "Input"],
Cell[52494, 1604, 41, 1, 27, "Input"],
Cell[52538, 1607, 61, 1, 27, "Input"],
Cell[52602, 1610, 47, 1, 27, "Input"],
Cell[52652, 1613, 61, 1, 27, "Input"],
Cell[52716, 1616, 43, 1, 27, "Input"],
Cell[52762, 1619, 38, 1, 27, "Input"],
Cell[52803, 1622, 57, 1, 27, "Input"],
Cell[52863, 1625, 88, 1, 27, "Input"],
Cell[52954, 1628, 61, 1, 27, "Input"],
Cell[53018, 1631, 38, 0, 31, "Text"],
Cell[53059, 1633, 75, 0, 31, "Text"],
Cell[53137, 1635, 38, 0, 31, "Text"],
Cell[53178, 1637, 76, 1, 27, "Input"],
Cell[53257, 1640, 71, 1, 27, "Input"],
Cell[53331, 1643, 58, 1, 27, "Input"],
Cell[53392, 1646, 88, 1, 27, "Input"],
Cell[53483, 1649, 58, 1, 27, "Input"],
Cell[53544, 1652, 61, 1, 27, "Input"],
Cell[53608, 1655, 47, 1, 27, "Input"],
Cell[53658, 1658, 88, 1, 27, "Input"],
Cell[53749, 1661, 66, 1, 27, "Input"],
Cell[53818, 1664, 61, 1, 27, "Input"],
Cell[53882, 1667, 141, 2, 43, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[54060, 1674, 59, 0, 28, "Subsubsection"],
Cell[54122, 1676, 121, 3, 48, "Text"],
Cell[54246, 1681, 155, 4, 27, "Input",
  Evaluatable->False],
Cell[54404, 1687, 99, 3, 31, "Text"],
Cell[54506, 1692, 137, 3, 27, "Input",
  Evaluatable->False],
Cell[54646, 1697, 108, 2, 31, "Text"],
Cell[54757, 1701, 358, 8, 116, "Text"],
Cell[55118, 1711, 162, 4, 65, "Text"],
Cell[55283, 1717, 139, 3, 48, "Text"],
Cell[55425, 1722, 211, 9, 150, "Text"],
Cell[55639, 1733, 224, 4, 65, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[55900, 1742, 77, 1, 28, "Subsubsection"],
Cell[55980, 1745, 225, 5, 65, "Text"],
Cell[56208, 1752, 204, 5, 48, "Text"],
Cell[56415, 1759, 74, 1, 31, "Text"],
Cell[56492, 1762, 662, 18, 252, "Text"],
Cell[57157, 1782, 74, 1, 31, "Text"],
Cell[57234, 1785, 52, 1, 31, "Text"],
Cell[57289, 1788, 171, 4, 48, "Text"],
Cell[57463, 1794, 449, 8, 99, "Text"],
Cell[57915, 1804, 660, 12, 134, "Text"],
Cell[58578, 1818, 42, 1, 31, "Text"],
Cell[58623, 1821, 735, 15, 218, "Text"],
Cell[59361, 1838, 394, 8, 116, "Text"],
Cell[59758, 1848, 246, 7, 99, "Text"],
Cell[60007, 1857, 147, 5, 65, "Text"],
Cell[60157, 1864, 197, 5, 48, "Text"],
Cell[60357, 1871, 574, 11, 150, "Text"],
Cell[60934, 1884, 1019, 23, 238, "Text"],

Cell[CellGroupData[{
Cell[61978, 1911, 108, 3, 27, "Input",
  Evaluatable->False],
Cell[62089, 1916, 126, 3, 27, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[62252, 1924, 233, 6, 56, "Input",
  Evaluatable->False],
Cell[62488, 1932, 296, 6, 59, "Output"]
}, Closed]],
Cell[62799, 1941, 577, 12, 152, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[63401, 1957, 89, 3, 27, "Input",
  Evaluatable->False],
Cell[63493, 1962, 57, 2, 23, "Print"],
Cell[63553, 1966, 57, 2, 23, "Print"]
}, Closed]],
Cell[63625, 1971, 187, 5, 45, "Text"],

Cell[CellGroupData[{
Cell[63837, 1980, 648, 13, 171, "Input",
  Evaluatable->False],
Cell[64488, 1995, 329, 6, 72, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[64854, 2006, 89, 3, 24, "Input",
  Evaluatable->False],
Cell[64946, 2011, 219, 4, 20, "Message"],
Cell[65168, 2017, 290, 5, 33, "Message"],
Cell[65461, 2024, 60, 2, 40, "Output"]
}, Closed]],
Cell[65536, 2029, 186, 5, 45, "Text"],
Cell[65725, 2036, 589, 11, 203, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[66339, 2051, 135, 4, 27, "Input",
  Evaluatable->False],
Cell[66477, 2057, 200, 4, 33, "Message"]
}, Closed]],
Cell[66692, 2064, 94, 3, 27, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[66811, 2071, 173, 5, 43, "Input",
  Evaluatable->False],
Cell[66987, 2078, 55, 2, 23, "Print"],
Cell[67045, 2082, 55, 2, 23, "Print"],
Cell[67103, 2086, 60, 2, 29, "Output"]
}, Closed]],
Cell[67178, 2091, 138, 4, 48, "Text"],
Cell[67319, 2097, 99, 3, 27, "Input",
  Evaluatable->False],
Cell[67421, 2102, 272, 7, 66, "Text"],

Cell[CellGroupData[{
Cell[67718, 2113, 159, 4, 43, "Input",
  Evaluatable->False],
Cell[67880, 2119, 131, 5, 29, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[68048, 2129, 89, 3, 27, "Input",
  Evaluatable->False],
Cell[68140, 2134, 58, 2, 27, "Output"]
}, Closed]],
Cell[68213, 2139, 281, 8, 48, "Text"],
Cell[68497, 2149, 839, 15, 287, "Text"]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

